VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsColorDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

  ' public enums

  Public Enum CDColorFlags
    CC_ANYCOLOR = &H100
    CC_ENABLEHOOK = &H10
    CC_ENABLETEMPLATE = &H20
    CC_ENABLETEMPLATEHANDLE = &H40
    CC_FULLOPEN = &H2
    CC_PREVENTFULLOPEN = &H4
    CC_RGBINIT = &H1
    CC_SHOWHELP = &H8
    CC_SOLIDCOLOR = &H80
  End Enum


  ' local constants

  ' constants used with SystemParametersInfo()
  #If Debuging Then
    Private Const SPI_GETBEEP = &H1
    Private Const SPI_SETBEEP = &H2
    Private Const SPI_GETMOUSE = &H3
    Private Const SPI_SETMOUSE = &H4
    Private Const SPI_GETBORDER = &H5
    Private Const SPI_SETBORDER = &H6
    Private Const SPI_GETKEYBOARDSPEED = &HA
    Private Const SPI_SETKEYBOARDSPEED = &HB
    Private Const SPI_LANGDRIVER = &HC
    Private Const SPI_ICONHORIZONTALSPACING = &HD
    Private Const SPI_GETSCREENSAVETIMEOUT = &HE
    Private Const SPI_SETSCREENSAVETIMEOUT = &HF
    Private Const SPI_GETSCREENSAVEACTIVE = &H10
    Private Const SPI_SETSCREENSAVEACTIVE = &H11
    Private Const SPI_GETGRIDGRANULARITY = &H12
    Private Const SPI_SETGRIDGRANULARITY = &H13
    Private Const SPI_SETDESKWALLPAPER = &H14
    Private Const SPI_SETDESKPATTERN = &H15
    Private Const SPI_GETKEYBOARDDELAY = &H16
    Private Const SPI_SETKEYBOARDDELAY = &H17
    Private Const SPI_ICONVERTICALSPACING = &H18
    Private Const SPI_GETICONTITLEWRAP = &H19
    Private Const SPI_SETICONTITLEWRAP = &H1A
    Private Const SPI_GETMENUDROPALIGNMENT = &H1B
    Private Const SPI_SETMENUDROPALIGNMENT = &H1C
    Private Const SPI_SETDOUBLECLKWIDTH = &H1D
    Private Const SPI_SETDOUBLECLKHEIGHT = &H1E
    Private Const SPI_GETICONTITLELOGFONT = &H1F
    Private Const SPI_SETDOUBLECLICKTIME = &H20
    Private Const SPI_SETMOUSEBUTTONSWAP = &H21
    Private Const SPI_SETICONTITLELOGFONT = &H22
    Private Const SPI_GETFASTTASKSWITCH = &H23
    Private Const SPI_SETFASTTASKSWITCH = &H24
    Private Const SPI_SETDRAGFULLWINDOWS = &H25
    Private Const SPI_GETDRAGFULLWINDOWS = &H26
    Private Const SPI_GETNONCLIENTMETRICS = &H29
    Private Const SPI_SETNONCLIENTMETRICS = &H2A
    Private Const SPI_GETMINIMIZEDMETRICS = &H2B
    Private Const SPI_SETMINIMIZEDMETRICS = &H2C
    Private Const SPI_GETICONMETRICS = &H2D
    Private Const SPI_SETICONMETRICS = &H2E
    Private Const SPI_SETWORKAREA = &H2F
    Private Const SPI_SETPENWINDOWS = &H31
    Private Const SPI_GETHIGHCONTRAST = &H42
    Private Const SPI_SETHIGHCONTRAST = &H43
    Private Const SPI_GETKEYBOARDPREF = &H44
    Private Const SPI_SETKEYBOARDPREF = &H45
    Private Const SPI_GETSCREENREADER = &H46
    Private Const SPI_SETSCREENREADER = &H47
    Private Const SPI_GETANIMATION = &H48
    Private Const SPI_SETANIMATION = &H49
    Private Const SPI_GETFONTSMOOTHING = &H4A
    Private Const SPI_SETFONTSMOOTHING = &H4B
    Private Const SPI_SETDRAGWIDTH = &H4C
    Private Const SPI_SETDRAGHEIGHT = &H4D
    Private Const SPI_SETHANDHELD = &H4E
    Private Const SPI_GETLOWPOWERTIMEOUT = &H4F
    Private Const SPI_GETPOWEROFFTIMEOUT = &H50
    Private Const SPI_SETLOWPOWERTIMEOUT = &H51
    Private Const SPI_SETPOWEROFFTIMEOUT = &H52
    Private Const SPI_GETLOWPOWERACTIVE = &H53
    Private Const SPI_GETPOWEROFFACTIVE = &H54
    Private Const SPI_SETLOWPOWERACTIVE = &H55
    Private Const SPI_SETPOWEROFFACTIVE = &H56
    Private Const SPI_SETCURSORS = &H57
    Private Const SPI_SETICONS = &H58
    Private Const SPI_GETDEFAULTINPUTLANG = &H59
    Private Const SPI_SETDEFAULTINPUTLANG = &H5A
    Private Const SPI_SETLANGTOGGLE = &H5B
    Private Const SPI_GETWINDOWSEXTENSION = &H5C
    Private Const SPI_SETMOUSETRAILS = &H5D
    Private Const SPI_GETMOUSETRAILS = &H5E
    Private Const SPI_SETSCREENSAVERRUNNING = &H61
    Private Const SPI_SCREENSAVERRUNNING = SPI_SETSCREENSAVERRUNNING
    Private Const SPI_GETFILTERKEYS = &H32
    Private Const SPI_SETFILTERKEYS = &H33
    Private Const SPI_GETTOGGLEKEYS = &H34
    Private Const SPI_SETTOGGLEKEYS = &H35
    Private Const SPI_GETMOUSEKEYS = &H36
    Private Const SPI_SETMOUSEKEYS = &H37
    Private Const SPI_GETSHOWSOUNDS = &H38
    Private Const SPI_SETSHOWSOUNDS = &H39
    Private Const SPI_GETSTICKYKEYS = &H3A
    Private Const SPI_SETSTICKYKEYS = &H3B
    Private Const SPI_GETACCESSTIMEOUT = &H3C
    Private Const SPI_SETACCESSTIMEOUT = &H3D
    Private Const SPI_GETSERIALKEYS = &H3E
    Private Const SPI_SETSERIALKEYS = &H3F
    Private Const SPI_GETSOUNDSENTRY = &H40
    Private Const SPI_SETSOUNDSENTRY = &H41
    Private Const SPI_GETSNAPTODEFBUTTON = &H5F
    Private Const SPI_SETSNAPTODEFBUTTON = &H60
    Private Const SPI_GETMOUSEHOVERWIDTH = &H62
    Private Const SPI_SETMOUSEHOVERWIDTH = &H63
    Private Const SPI_GETMOUSEHOVERHEIGHT = &H64
    Private Const SPI_SETMOUSEHOVERHEIGHT = &H65
    Private Const SPI_GETMOUSEHOVERTIME = &H66
    Private Const SPI_SETMOUSEHOVERTIME = &H67
    Private Const SPI_GETWHEELSCROLLLINES = &H68
    Private Const SPI_SETWHEELSCROLLLINES = &H69
    Private Const SPI_GETMENUSHOWDELAY = &H6A
    Private Const SPI_SETMENUSHOWDELAY = &H6B
    Private Const SPI_GETSHOWIMEUI = &H6E
    Private Const SPI_SETSHOWIMEUI = &H6F
    Private Const SPI_GETMOUSESPEED = &H70
    Private Const SPI_SETMOUSESPEED = &H71
    Private Const SPI_GETSCREENSAVERRUNNING = &H72
    Private Const SPI_GETDESKWALLPAPER = &H73
    Private Const SPI_GETACTIVEWINDOWTRACKING = &H1000
    Private Const SPI_SETACTIVEWINDOWTRACKING = &H1001
    Private Const SPI_GETMENUANIMATION = &H1002
    Private Const SPI_SETMENUANIMATION = &H1003
    Private Const SPI_GETCOMBOBOXANIMATION = &H1004
    Private Const SPI_SETCOMBOBOXANIMATION = &H1005
    Private Const SPI_GETLISTBOXSMOOTHSCROLLING = &H1006
    Private Const SPI_SETLISTBOXSMOOTHSCROLLING = &H1007
    Private Const SPI_GETGRADIENTCAPTIONS = &H1008
    Private Const SPI_SETGRADIENTCAPTIONS = &H1009
    Private Const SPI_GETKEYBOARDCUES = &H100A
    Private Const SPI_SETKEYBOARDCUES = &H100B
    Private Const SPI_GETMENUUNDERLINES = SPI_GETKEYBOARDCUES
    Private Const SPI_SETMENUUNDERLINES = SPI_SETKEYBOARDCUES
    Private Const SPI_GETACTIVEWNDTRKZORDER = &H100C
    Private Const SPI_SETACTIVEWNDTRKZORDER = &H100D
    Private Const SPI_GETHOTTRACKING = &H100E
    Private Const SPI_SETHOTTRACKING = &H100F
    Private Const SPI_GETMENUFADE = &H1012
    Private Const SPI_SETMENUFADE = &H1013
    Private Const SPI_GETSELECTIONFADE = &H1014
    Private Const SPI_SETSELECTIONFADE = &H1015
    Private Const SPI_GETTOOLTIPANIMATION = &H1016
    Private Const SPI_SETTOOLTIPANIMATION = &H1017
    Private Const SPI_GETTOOLTIPFADE = &H1018
    Private Const SPI_SETTOOLTIPFADE = &H1019
    Private Const SPI_GETCURSORSHADOW = &H101A
    Private Const SPI_SETCURSORSHADOW = &H101B
    Private Const SPI_GETMOUSESONAR = &H101C
    Private Const SPI_SETMOUSESONAR = &H101D
    Private Const SPI_GETMOUSECLICKLOCK = &H101E
    Private Const SPI_SETMOUSECLICKLOCK = &H101F
    Private Const SPI_GETMOUSEVANISH = &H1020
    Private Const SPI_SETMOUSEVANISH = &H1021
    Private Const SPI_GETFLATMENU = &H1022
    Private Const SPI_SETFLATMENU = &H1023
    Private Const SPI_GETDROPSHADOW = &H1024
    Private Const SPI_SETDROPSHADOW = &H1025
    Private Const SPI_GETBLOCKSENDINPUTRESETS = &H1026
    Private Const SPI_SETBLOCKSENDINPUTRESETS = &H1027
    Private Const SPI_GETUIEFFECTS = &H103E
    Private Const SPI_SETUIEFFECTS = &H103F
    Private Const SPI_GETFOREGROUNDLOCKTIMEOUT = &H2000
    Private Const SPI_SETFOREGROUNDLOCKTIMEOUT = &H2001
    Private Const SPI_GETACTIVEWNDTRKTIMEOUT = &H2002
    Private Const SPI_SETACTIVEWNDTRKTIMEOUT = &H2003
    Private Const SPI_GETFOREGROUNDFLASHCOUNT = &H2004
    Private Const SPI_SETFOREGROUNDFLASHCOUNT = &H2005
    Private Const SPI_GETCARETWIDTH = &H2006
    Private Const SPI_SETCARETWIDTH = &H2007
    Private Const SPI_GETMOUSECLICKLOCKTIME = &H2008
    Private Const SPI_SETMOUSECLICKLOCKTIME = &H2009
    Private Const SPI_GETFONTSMOOTHINGTYPE = &H200A
    Private Const SPI_SETFONTSMOOTHINGTYPE = &H200B
    Private Const SPI_GETFONTSMOOTHINGCONTRAST = &H200C
    Private Const SPI_SETFONTSMOOTHINGCONTRAST = &H200D
    Private Const SPI_GETFOCUSBORDERWIDTH = &H200E
    Private Const SPI_SETFOCUSBORDERWIDTH = &H200F
    Private Const SPI_GETFOCUSBORDERHEIGHT = &H2010
    Private Const SPI_SETFOCUSBORDERHEIGHT = &H2011
    Private Const SPI_GETFONTSMOOTHINGORIENTATION = &H2012
    Private Const SPI_SETFONTSMOOTHINGORIENTATION = &H2013
    Private Const SPIF_UPDATEINIFILE = &H1
    Private Const SPIF_SENDWININICHANGE = &H2
    Private Const SPIF_SENDCHANGE = SPIF_SENDWININICHANGE
  #End If
  Private Const SPI_GETWORKAREA = &H30


  ' local UDTs

  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Private Type TCHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    Flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
  End Type


  ' local vars

  Private mASM() As Byte


  ' vars used to store the values of public properties

  Private propColorFlags As CDColorFlags
  Private propCustomColors(15) As Long
  Private propDefaultColor As Long
  Private prophWndParent As Long
  Private propUseCustomColors As Boolean
  Private propUseDefaultColor As Boolean


  ' local API-declarations

  Private Declare Function ChooseColor Lib "comdlg32" Alias "ChooseColorA" (Data As TCHOOSECOLOR) As Long
  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Ziel As Any, Quelle As Any, ByVal Size As Long)
  Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
  Private Declare Function GetSysColor Lib "user32" (ByVal Index As Long) As Long
  Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, rc As RECT) As Long
  Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal Repaint As Long) As Long
  Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal ParamInfo As Long, ByVal ParamData1 As Long, ParamData2 As Any, ByVal Flags As Long) As Long


' events

Private Sub Class_Initialize()
  Dim ptr As Long

  ' get the VTable-Ptr
  CopyMemory ptr, ByVal ObjPtr(Me), LenB(ptr)
  ' get the pointer to the first public procedure (must be our WinMain)
  CopyMemory ptr, ByVal ptr + &H1C, LenB(ptr)
  ReDim mASM(0 To 42) As Byte     ' bytes 38 to 42 will receive the return value of our WinMain
  ' lay the frame pointer onto the stack (what for?)
  mASM(0) = &H55     ' PUSH EBP
  ' get the stack pointer into EBP
  CopyMemory mASM(1), &H68EC8B, 3     ' MOV EBP, ESP
  ' lay the offset of the return value's address onto the stack
  CopyMemory mASM(4), VarPtr(mASM(39)), 4   ' PUSH dword ptr [offset of return address]

  ' lay the addresses of the WinMain's arguments onto the stack
  ' 4th argument
  CopyMemory mASM(8), &H1475FF, 3     ' PUSH dword ptr [EBP+14h]
  ' 3rd argument
  CopyMemory mASM(11), &H1075FF, 3     ' PUSH dword ptr [EBP+10h]
  ' 2nd argument
  CopyMemory mASM(14), &HC75FF, 3     ' PUSH dword ptr [EBP+0Ch]
  ' 1st argument
  CopyMemory mASM(17), &H875FF, 3     ' PUSH dword ptr [EBP+08h]

  ' lay the current object's pointer onto the stack
  mASM(20) = &H68     ' PUSH 32-bit-immediate
  CopyMemory mASM(21), ObjPtr(Me), 4     ' the immediate
  ' call our WinMain
  mASM(25) = &HE8     ' CALL 32-bit relative code address
  CopyMemory mASM(26), ptr - VarPtr(mASM(30)), 4    ' the relative address
  ' move the WinMain's return value into EAX
  mASM(30) = &HA1     ' MOV EAX, dword ptr [offset of return address]
  CopyMemory mASM(31), VarPtr(mASM(39)), 4     ' the offset
  ' leave our WinMain
  mASM(35) = &HC9     ' LEAVE
  ' return from our WinMain
  mASM(36) = &HC2     ' RET 10h     (seems to be some offset - it's the size of all arguments together)
  CopyMemory mASM(37), &H10, 2    ' can't do the "RET 10h" in 1 line - probably alignment problems
End Sub


' This must be the first public method!!
' disadvantage of the Assembler trick: we now have 1 method for all dialogs
Public Function GenericHookProc(ByVal hDlg As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Const WM_INITDIALOG = &H110
  Dim hWnd As Long
  Dim rc As RECT
  Dim rc2 As RECT
  Dim X As Long
  Dim Y As Long

  Select Case msg
    Case WM_INITDIALOG
      hWnd = GetParent(hDlg)
      GetWindowRect hWnd, rc
      If SystemParametersInfo(SPI_GETWORKAREA, 0, rc2, 0) = 0 Then
        ' call failed - just use standard screen:
        rc2.Left = 0
        rc2.Top = 0
        rc2.Right = Screen.Width \ Screen.TwipsPerPixelX
        rc2.Bottom = Screen.Height \ Screen.TwipsPerPixelY
      End If
      If (rc.Right > 0) And (rc.Bottom > 0) Then
        X = rc2.Left + (((rc2.Right - rc2.Left) - (rc.Right - rc.Left)) \ 2)
        Y = rc2.Top + (((rc2.Bottom - rc2.Top) - (rc.Bottom - rc.Top)) \ 2)
        MoveWindow hWnd, X, Y, rc.Right - rc.Left, rc.Bottom - rc.Top, 1
      End If
  End Select
End Function


' public properties

Public Property Get ColorFlags() As CDColorFlags
  ColorFlags = propColorFlags
End Property

Public Property Let ColorFlags(ByVal New_ColorFlags As CDColorFlags)
  propColorFlags = New_ColorFlags
End Property

Public Property Get CustomColors(ByVal Index As Integer) As Long
  If Not isValidNumber(Index, 0, 15) Then Exit Property

  CustomColors = propCustomColors(Index)
End Property

Public Property Let CustomColors(ByVal Index As Integer, ByVal New_CustomColors As Long)
  If Not isValidNumber(Index, 0, 15) Then Exit Property

  propCustomColors(Index) = New_CustomColors
End Property

Public Property Get DefaultColor() As Long
  DefaultColor = propDefaultColor
End Property

Public Property Let DefaultColor(ByVal New_DefaultColor As Long)
  propDefaultColor = New_DefaultColor
End Property

Public Property Get hWndParent() As Long
  hWndParent = prophWndParent
End Property

Public Property Let hWndParent(ByVal New_hWndParent As Long)
  prophWndParent = New_hWndParent
End Property

Public Property Get UseCustomColors() As Boolean
  UseCustomColors = propUseCustomColors
End Property

Public Property Let UseCustomColors(ByVal New_UseCustomColors As Boolean)
  propUseCustomColors = New_UseCustomColors
End Property

Public Property Get UseDefaultColor() As Boolean
  UseDefaultColor = propUseDefaultColor
End Property

Public Property Let UseDefaultColor(ByVal New_UseDefaultColor As Boolean)
  propUseDefaultColor = New_UseDefaultColor
End Property


' local methods

' checks whether <txt> is a valid number between <LoBound> and <HiBound>
Private Function isValidNumber(ByVal txt As String, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  Dim i As Integer
  Dim ret As Boolean
  Dim tmp As String

  If txt = "" Then Exit Function

  ret = True

  tmp = txt
  If Left(tmp, 1) = "-" Then tmp = Mid(tmp, 2)

  ' we need to check every single char
  For i = 1 To Len(tmp)
    If InStr("0123456789", Mid(tmp, i, 1)) = 0 Then ret = False
  Next
  If ret Then
    ' check the bounds
    ret = isWithinRange(CLng(txt), LoBound, HiBound)
  End If

  isValidNumber = ret
End Function

' checks whether <Num> is placed between <LoBound> and <HiBound>
Private Function isWithinRange(ByVal Num As Long, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  isWithinRange = ((Num >= LoBound) And (Num <= HiBound))
End Function

' fills <propCustomColors> with the color white
Private Sub WhiteToCustomColors()
  Dim i As Integer

  For i = LBound(propCustomColors) To UBound(propCustomColors)
    propCustomColors(i) = ColorConstants.vbWhite
  Next
End Sub


' public methods

' pops up a "Choose color..."-dialog and returns the selected color
Public Function showColor(Color As Long) As Boolean
  Dim Data As TCHOOSECOLOR
  Dim ret As Boolean

  ' prepare the API call
  With Data
    .Flags = propColorFlags
    .hInstance = App.hInstance
    .hwndOwner = prophWndParent
    If Not propUseCustomColors Then WhiteToCustomColors
    .lpCustColors = VarPtr(propCustomColors(0))
    If propUseDefaultColor Then
      .Flags = .Flags Or CDColorFlags.CC_RGBINIT
      .rgbResult = propDefaultColor
    End If
    #If UseHooking Then
      ' ToDo: doesn't seem to work
      .Flags = .Flags Or CDColorFlags.CC_ENABLEHOOK
      .lpfnHook = VarPtr(mASM(0))
    #End If
    .lStructSize = LenB(Data)

    ' show up the dialog
    ret = ChooseColor(Data)

    If ret Then
      ' return the selected color
      Color = .rgbResult
    End If
  End With

  showColor = ret
End Function

' fills <propCustomColors> with the first 16 system colors
Public Sub SysColorsToCustomColors()
  Dim i As Integer

  For i = LBound(propCustomColors) To UBound(propCustomColors)
    propCustomColors(i) = GetSysColor(i)
  Next
End Sub
