VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPrinterDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

  ' local enums

  Private Enum CDFields
    DM_ORIENTATION = &H1
    DM_PAPERSIZE = &H2
    DM_PAPERLENGTH = &H4
    DM_PAPERWIDTH = &H8
    DM_SCALE = &H10
    DM_POSITION = &H20
    DM_COPIES = &H100
    DM_DEFAULTSOURCE = &H200
    DM_PRINTQUALITY = &H400
    DM_COLOR = &H800
    DM_DUPLEX = &H1000
    DM_YRESOLUTION = &H2000
    DM_TTOPTION = &H4000
    DM_COLLATE = &H8000
    DM_FORMNAME = &H10000
    DM_LOGPIXELS = &H20000
    DM_BITSPERPEL = &H40000
    DM_PELSWIDTH = &H80000
    DM_PELSHEIGHT = &H100000
    DM_DISPLAYFLAGS = &H200000
    DM_DISPLAYFREQUENCY = &H400000
    DM_ICMMETHOD = &H800000
    DM_ICMINTENT = &H1000000
    DM_MEDIATYPE = &H2000000
    DM_DITHERTYPE = &H4000000
    DM_PANNINGWIDTH = &H8000000
    DM_PANNINGHEIGHT = &H10000000
  End Enum


  ' public enums

  Public Enum CDDuplexConsts
    DMDUP_SIMPLEX = 1    ' no duplex
    DMDUP_VERTICAL = 2   ' tablet
    DMDUP_HORIZONTAL = 3 ' book
  End Enum

  Public Enum CDICMConsts
    DMICMMETHOD_NONE = 1   ' no ICM
    DMICMMETHOD_SYSTEM = 2 ' ICM will be done by system
    DMICMMETHOD_DRIVER = 3 ' ICM will be done by driver
    DMICMMETHOD_DEVICE = 4 ' ICM will be done by hardware
  End Enum

  Public Enum CDICMModeConsts
    DMICM_SATURATE = 1         ' maximum saturation
    DMICM_CONTRAST = 2         ' maximum contrast
    DMICM_COLORIMETRIC = 3     ' maximum color precision (correction)
    DMICM_ABS_COLORIMETRIC = 4 ' maximum color precision
  End Enum

  Public Enum CDMediaTypeConsts
    DMMEDIA_STANDARD = 1
    DMMEDIA_TRANSPARENCY = 2
    DMMEDIA_GLOSSY = 3
  End Enum

  Public Enum CDOrientationConsts
    DMORIENT_PORTRAIT = 1
    DMORIENT_LANDSCAPE = 2
  End Enum

  Public Enum CDPageSetupFlags
    PSD_DEFAULTMINMARGINS = &H0
    PSD_DISABLEMARGINS = &H10
    PSD_DISABLEORIENTATION = &H100
    PSD_DISABLEPAGEPAINTING = &H80000
    PSD_DISABLEPAPER = &H200
    PSD_DISABLEPRINTER = &H20
    PSD_ENABLEPAGEPAINTHOOK = &H40000
    PSD_ENABLEPAGESETUPHOOK = &H2000
    PSD_ENABLEPAGESETUPTEMPLATE = &H8000
    PSD_ENABLEPAGESETUPTEMPLATEHANDLE = &H20000
    PSD_INHUNDREDTHSOFMILLIMETERS = &H8
    PSD_INTHOUSANDTHSOFINCHES = &H4
    PSD_INWININIINTLMEASURE = &H0
    PSD_MARGINS = &H2
    PSD_MINMARGINS = &H1
    PSD_NONETWORKBUTTON = &H200000
    PSD_NOWARNING = &H80
    PSD_RETURNDEFAULT = &H400
    PSD_SHOWHELP = &H800
  End Enum

  Public Enum CDPaperSizeConsts
    DMPAPER_LETTER = 1                         ' Letter 8 1/2 x 11 in
    DMPAPER_LETTERSMALL = 2                    ' Letter Small 8 1/2 x 11 in
    DMPAPER_TABLOID = 3                        ' Tabloid 11 x 17 in
    DMPAPER_LEDGER = 4                         ' Ledger 17 x 11 in
    DMPAPER_LEGAL = 5                          ' Legal 8 1/2 x 14 in
    DMPAPER_STATEMENT = 6                      ' Statement 5 1/2 x 8 1/2 in
    DMPAPER_EXECUTIVE = 7                      ' Executive 7 1/4 x 10 1/2 in
    DMPAPER_A3 = 8                             ' A3 297 x 420 mm
    DMPAPER_A4 = 9                             ' A4 210 x 297 mm
    DMPAPER_A4SMALL = 10                       ' A4 Small 210 x 297 mm
    DMPAPER_A5 = 11                            ' A5 148 x 210 mm
    DMPAPER_B4 = 12                            ' B4 (JIS) 250 x 354
    DMPAPER_B5 = 13                            ' B5 (JIS) 182 x 257 mm
    DMPAPER_FOLIO = 14                         ' Folio 8 1/2 x 13 in
    DMPAPER_QUARTO = 15                        ' Quarto 215 x 275 mm
    DMPAPER_10x14 = 16                         ' 10x14 in
    DMPAPER_11x17 = 17                         ' 11x17 in
    DMPAPER_NOTE = 18                          ' Note 8 1/2 x 11 in
    DMPAPER_ENV_9 = 19                         ' Envelope #9 3 7/8 x 8 7/8
    DMPAPER_ENV_10 = 20                        ' Envelope #10 4 1/8 x 9 1/2
    DMPAPER_ENV_11 = 21                        ' Envelope #11 4 1/2 x 10 3/8
    DMPAPER_ENV_12 = 22                        ' Envelope #12 4 \276 x 11
    DMPAPER_ENV_14 = 23                        ' Envelope #14 5 x 11 1/2
    DMPAPER_CSHEET = 24                        ' C size sheet
    DMPAPER_DSHEET = 25                        ' D size sheet
    DMPAPER_ESHEET = 26                        ' E size sheet
    DMPAPER_ENV_DL = 27                        ' Envelope DL 110 x 220mm
    DMPAPER_ENV_C5 = 28                        ' Envelope C5 162 x 229 mm
    DMPAPER_ENV_C3 = 29                        ' Envelope C3  324 x 458 mm
    DMPAPER_ENV_C4 = 30                        ' Envelope C4  229 x 324 mm
    DMPAPER_ENV_C6 = 31                        ' Envelope C6  114 x 162 mm
    DMPAPER_ENV_C65 = 32                       ' Envelope C65 114 x 229 mm
    DMPAPER_ENV_B4 = 33                        ' Envelope B4  250 x 353 mm
    DMPAPER_ENV_B5 = 34                        ' Envelope B5  176 x 250 mm
    DMPAPER_ENV_B6 = 35                        ' Envelope B6  176 x 125 mm
    DMPAPER_ENV_ITALY = 36                     ' Envelope 110 x 230 mm
    DMPAPER_ENV_MONARCH = 37                   ' Envelope Monarch 3.875 x 7.5 in
    DMPAPER_ENV_PERSONAL = 38                  ' 6 3/4 Envelope 3 5/8 x 6 1/2 in
    DMPAPER_FANFOLD_US = 39                    ' US Std Fanfold 14 7/8 x 11 in
    DMPAPER_FANFOLD_STD_GERMAN = 40            ' German Std Fanfold 8 1/2 x 12 in
    DMPAPER_FANFOLD_LGL_GERMAN = 41            ' German Legal Fanfold 8 1/2 x 13 in
    DMPAPER_ISO_B4 = 42                        ' B4 (ISO) 250 x 353 mm
    DMPAPER_JAPANESE_POSTCARD = 43             ' Japanese Postcard 100 x 148 mm
    DMPAPER_9X11 = 44                          ' 9 x 11 in
    DMPAPER_1 = &H11 = 45                      ' 10 x 11 in
    DMPAPER_15X11 = 46                         ' 15 x 11 in
    DMPAPER_ENV_INVITE = 47                    ' Envelope Invite 220 x 220 mm
    DMPAPER_RESERVED_48 = 48                   ' RESERVED--DO NOT USE
    DMPAPER_RESERVED_49 = 49                   ' RESERVED--DO NOT USE
    DMPAPER_LETTER_EXTRA = 50                  ' Letter Extra 9 \275 x 12 in
    DMPAPER_LEGAL_EXTRA = 51                   ' Legal Extra 9 \275 x 15 in
    DMPAPER_TABLOID_EXTRA = 52                 ' Tabloid Extra 11.69 x 18 in
    DMPAPER_A4_EXTRA = 53                      ' A4 Extra 9.27 x 12.69 in
    DMPAPER_LETTER_TRANSVERSE = 54             ' Letter Transverse 8 \275 x 11 in
    DMPAPER_A4_TRANSVERSE = 55                 ' A4 Transverse 210 x 297 mm
    DMPAPER_LETTER_EXTRA_TRANSVERSE = 56       ' Letter Extra Transverse 9\275 x 12 in
    DMPAPER_A_PLUS = 57                        ' SuperA/SuperA/A4 227 x 356 mm
    DMPAPER_B_PLUS = 58                        ' SuperB/SuperB/A3 305 x 487 mm
    DMPAPER_LETTER_PLUS = 59                   ' Letter Plus 8.5 x 12.69 in
    DMPAPER_A4_PLUS = 60                       ' A4 Plus 210 x 330 mm
    DMPAPER_A5_TRANSVERSE = 61                 ' A5 Transverse 148 x 210 mm
    DMPAPER_B5_TRANSVERSE = 62                 ' B5 (JIS) Transverse 182 x 257 mm
    DMPAPER_A3_EXTRA = 63                      ' A3 Extra 322 x 445 mm
    DMPAPER_A5_EXTRA = 64                      ' A5 Extra 174 x 235 mm
    DMPAPER_B5_EXTRA = 65                      ' B5 (ISO) Extra 201 x 276 mm
    DMPAPER_A2 = 66                            ' A2 420 x 594 mm
    DMPAPER_A3_TRANSVERSE = 67                 ' A3 Transverse 297 x 420 mm
    DMPAPER_A3_EXTRA_TRANSVERSE = 68           ' A3 Extra Transverse 322 x 445 mm
    DMPAPER_DBL_JAPANESE_POSTCARD = 69         ' Japanese Double Postcard 200 x 148 mm
    DMPAPER_A6 = 70                            ' A6 105 x 148 mm
    DMPAPER_JENV_KAKU2 = 71                    ' Japanese Envelope Kaku #2
    DMPAPER_JENV_KAKU3 = 72                    ' Japanese Envelope Kaku #3
    DMPAPER_JENV_CHOU3 = 73                    ' Japanese Envelope Chou #3
    DMPAPER_JENV_CHOU4 = 74                    ' Japanese Envelope Chou #4
    DMPAPER_LETTER_ROTATED = 75                ' Letter Rotated 11 x 8 1/2 11 in
    DMPAPER_A3_ROTATED = 76                    ' A3 Rotated 420 x 297 mm
    DMPAPER_A4_ROTATED = 77                    ' A4 Rotated 297 x 210 mm
    DMPAPER_A5_ROTATED = 78                    ' A5 Rotated 210 x 148 mm
    DMPAPER_B4_JIS_ROTATED = 79                ' B4 (JIS) Rotated 364 x 257 mm
    DMPAPER_B5_JIS_ROTATED = 80                ' B5 (JIS) Rotated 257 x 182 mm
    DMPAPER_JAPANESE_POSTCARD_ROTATED = 81     ' Japanese Postcard Rotated 148 x 100 mm
    DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED = 82 ' Double Japanese Postcard Rotated 148 x 200 mm
    DMPAPER_A6_ROTATED = 83                    ' A6 Rotated 148 x 105 mm
    DMPAPER_JENV_KAKU2_ROTATED = 84            ' Japanese Envelope Kaku #2 Rotated
    DMPAPER_JENV_KAKU3_ROTATED = 85            ' Japanese Envelope Kaku #3 Rotated
    DMPAPER_JENV_CHOU3_ROTATED = 86            ' Japanese Envelope Chou #3 Rotated
    DMPAPER_JENV_CHOU4_ROTATED = 87            ' Japanese Envelope Chou #4 Rotated
    DMPAPER_B6_JIS = 88                        ' B6 (JIS) 128 x 182 mm
    DMPAPER_B6_JIS_ROTATED = 89                ' B6 (JIS) Rotated 182 x 128 mm
    DMPAPER_12X11 = 90                         ' 12 x 11 in
    DMPAPER_JENV_YOU4 = 91                     ' Japanese Envelope You #4
    DMPAPER_JENV_YOU4_ROTATED = 92             ' Japanese Envelope You #4 Rotated
    DMPAPER_P16K = 93                          ' PRC 16K 146 x 215 mm
    DMPAPER_P32K = 94                          ' PRC 32K 97 x 151 mm
    DMPAPER_P32KBIG = 95                       ' PRC 32K(Big) 97 x 151 mm
    DMPAPER_PENV_1 = 96                        ' PRC Envelope #1 102 x 165 mm
    DMPAPER_PENV_2 = 97                        ' PRC Envelope #2 102 x 176 mm
    DMPAPER_PENV_3 = 98                        ' PRC Envelope #3 125 x 176 mm
    DMPAPER_PENV_4 = 99                        ' PRC Envelope #4 110 x 208 mm
    DMPAPER_PENV_5 = 100                       ' PRC Envelope #5 110 x 220 mm
    DMPAPER_PENV_6 = 101                       ' PRC Envelope #6 120 x 230 mm
    DMPAPER_PENV_7 = 102                       ' PRC Envelope #7 160 x 230 mm
    DMPAPER_PENV_8 = 103                       ' PRC Envelope #8 120 x 309 mm
    DMPAPER_PENV_9 = 104                       ' PRC Envelope #9 229 x 324 mm
    DMPAPER_PENV_10 = 105                      ' PRC Envelope #10 324 x 458 mm
    DMPAPER_P16K_ROTATED = 106                 ' PRC 16K Rotated
    DMPAPER_P32K_ROTATED = 107                 ' PRC 32K Rotated
    DMPAPER_P32KBIG_ROTATED = 108              ' PRC 32K(Big) Rotated
    DMPAPER_PENV_1_ROTATED = 109               ' PRC Envelope #1 Rotated 165 x 102 mm
    DMPAPER_PENV_2_ROTATED = 110               ' PRC Envelope #2 Rotated 176 x 102 mm
    DMPAPER_PENV_3_ROTATED = 111               ' PRC Envelope #3 Rotated 176 x 125 mm
    DMPAPER_PENV_4_ROTATED = 112               ' PRC Envelope #4 Rotated 208 x 110 mm
    DMPAPER_PENV_5_ROTATED = 113               ' PRC Envelope #5 Rotated 220 x 110 mm
    DMPAPER_PENV_6_ROTATED = 114               ' PRC Envelope #6 Rotated 230 x 120 mm
    DMPAPER_PENV_7_ROTATED = 115               ' PRC Envelope #7 Rotated 230 x 160 mm
    DMPAPER_PENV_8_ROTATED = 116               ' PRC Envelope #8 Rotated 309 x 120 mm
    DMPAPER_PENV_9_ROTATED = 117               ' PRC Envelope #9 Rotated 324 x 229 mm
    DMPAPER_PENV_10_ROTATED = 118              ' PRC Envelope #10 Rotated 458 x 324 mm
  End Enum

  Public Enum CDPaperSourceConsts
    DMBIN_UPPER = 1
    DMBIN_ONLYONE = 1
    DMBIN_LOWER = 2
    DMBIN_MIDDLE = 3
    DMBIN_MANUAL = 4
    DMBIN_ENVELOPE = 5
    DMBIN_ENVMANUAL = 6
    DMBIN_AUTO = 7
    DMBIN_TRACTOR = 8
    DMBIN_SMALLFMT = 9
    DMBIN_LARGEFMT = 10
    DMBIN_LARGECAPACITY = 11
    DMBIN_CASSETTE = 14
    DMBIN_FORMSOURCE = 15
  End Enum

  Public Enum CDPrintDlgExResultActionIDs
    PD_RESULT_CANCEL = 0
    PD_RESULT_PRINT = 1
    PD_RESULT_APPLY = 2
  End Enum

  Public Enum CDPrintDialogFlags
    PD_ALLPAGES = &H0
    PD_SELECTION = &H1
    PD_PAGENUMS = &H2
    PD_NOSELECTION = &H4
    PD_NOPAGENUMS = &H8
    PD_COLLATE = &H10
    PD_PRINTTOFILE = &H20
    PD_PRINTSETUP = &H40
    PD_NOWARNING = &H80
    PD_RETURNDC = &H100
    PD_RETURNIC = &H200
    PD_RETURNDEFAULT = &H400
    PD_SHOWHELP = &H800
    PD_ENABLEPRINTHOOK = &H1000
    PD_ENABLESETUPHOOK = &H2000
    PD_ENABLEPRINTTEMPLATE = &H4000
    PD_ENABLESETUPTEMPLATE = &H8000
    PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
    PD_ENABLESETUPTEMPLATEHANDLE = &H20000
    PD_USEDEVMODECOPIES = &H40000
    PD_USEDEVMODECOPIESANDCOLLATE = &H40000
    PD_DISABLEPRINTTOFILE = &H80000
    PD_HIDEPRINTTOFILE = &H100000
    PD_NONETWORKBUTTON = &H200000
    ' needs Windows  2000 or higher
    PD_CURRENTPAGE = &H400000
    PD_NOCURRENTPAGE = &H800000
    PD_EXCLUSIONFLAGS = &H1000000
    PD_USELARGETEMPLATE = &H10000000
  End Enum

  Public Enum CDPrintDialogExclusionFlags
    PD_EXCL_COPIESANDCOLLATE = (DM_COPIES Or DM_COLLATE)
  End Enum

  Public Enum CDPrintQualityConsts
    DMRES_DRAFT = -1
    DMRES_LOW = -2
    DMRES_MEDIUM = -3
    DMRES_HIGH = -4
  End Enum

  Public Enum CDTrueTypeConsts
    DMTT_BITMAP = 1           ' print TT fonts as graphics
    DMTT_DOWNLOAD = 2         ' download TT fonts as soft fonts
    DMTT_SUBDEV = 3           ' substitute device fonts for TT fonts
    DMTT_DOWNLOAD_OUTLINE = 4 ' download TT fonts as outline soft fonts
  End Enum


  ' local constants

  Private Const S_OK = &H0
  Private Const START_PAGE_GENERAL = &HFFFFFFFF

  ' constants used with SystemParametersInfo()
  #If Debuging Then
    Private Const SPI_GETBEEP = &H1
    Private Const SPI_SETBEEP = &H2
    Private Const SPI_GETMOUSE = &H3
    Private Const SPI_SETMOUSE = &H4
    Private Const SPI_GETBORDER = &H5
    Private Const SPI_SETBORDER = &H6
    Private Const SPI_GETKEYBOARDSPEED = &HA
    Private Const SPI_SETKEYBOARDSPEED = &HB
    Private Const SPI_LANGDRIVER = &HC
    Private Const SPI_ICONHORIZONTALSPACING = &HD
    Private Const SPI_GETSCREENSAVETIMEOUT = &HE
    Private Const SPI_SETSCREENSAVETIMEOUT = &HF
    Private Const SPI_GETSCREENSAVEACTIVE = &H10
    Private Const SPI_SETSCREENSAVEACTIVE = &H11
    Private Const SPI_GETGRIDGRANULARITY = &H12
    Private Const SPI_SETGRIDGRANULARITY = &H13
    Private Const SPI_SETDESKWALLPAPER = &H14
    Private Const SPI_SETDESKPATTERN = &H15
    Private Const SPI_GETKEYBOARDDELAY = &H16
    Private Const SPI_SETKEYBOARDDELAY = &H17
    Private Const SPI_ICONVERTICALSPACING = &H18
    Private Const SPI_GETICONTITLEWRAP = &H19
    Private Const SPI_SETICONTITLEWRAP = &H1A
    Private Const SPI_GETMENUDROPALIGNMENT = &H1B
    Private Const SPI_SETMENUDROPALIGNMENT = &H1C
    Private Const SPI_SETDOUBLECLKWIDTH = &H1D
    Private Const SPI_SETDOUBLECLKHEIGHT = &H1E
    Private Const SPI_GETICONTITLELOGFONT = &H1F
    Private Const SPI_SETDOUBLECLICKTIME = &H20
    Private Const SPI_SETMOUSEBUTTONSWAP = &H21
    Private Const SPI_SETICONTITLELOGFONT = &H22
    Private Const SPI_GETFASTTASKSWITCH = &H23
    Private Const SPI_SETFASTTASKSWITCH = &H24
    Private Const SPI_SETDRAGFULLWINDOWS = &H25
    Private Const SPI_GETDRAGFULLWINDOWS = &H26
    Private Const SPI_GETNONCLIENTMETRICS = &H29
    Private Const SPI_SETNONCLIENTMETRICS = &H2A
    Private Const SPI_GETMINIMIZEDMETRICS = &H2B
    Private Const SPI_SETMINIMIZEDMETRICS = &H2C
    Private Const SPI_GETICONMETRICS = &H2D
    Private Const SPI_SETICONMETRICS = &H2E
    Private Const SPI_SETWORKAREA = &H2F
    Private Const SPI_SETPENWINDOWS = &H31
    Private Const SPI_GETHIGHCONTRAST = &H42
    Private Const SPI_SETHIGHCONTRAST = &H43
    Private Const SPI_GETKEYBOARDPREF = &H44
    Private Const SPI_SETKEYBOARDPREF = &H45
    Private Const SPI_GETSCREENREADER = &H46
    Private Const SPI_SETSCREENREADER = &H47
    Private Const SPI_GETANIMATION = &H48
    Private Const SPI_SETANIMATION = &H49
    Private Const SPI_GETFONTSMOOTHING = &H4A
    Private Const SPI_SETFONTSMOOTHING = &H4B
    Private Const SPI_SETDRAGWIDTH = &H4C
    Private Const SPI_SETDRAGHEIGHT = &H4D
    Private Const SPI_SETHANDHELD = &H4E
    Private Const SPI_GETLOWPOWERTIMEOUT = &H4F
    Private Const SPI_GETPOWEROFFTIMEOUT = &H50
    Private Const SPI_SETLOWPOWERTIMEOUT = &H51
    Private Const SPI_SETPOWEROFFTIMEOUT = &H52
    Private Const SPI_GETLOWPOWERACTIVE = &H53
    Private Const SPI_GETPOWEROFFACTIVE = &H54
    Private Const SPI_SETLOWPOWERACTIVE = &H55
    Private Const SPI_SETPOWEROFFACTIVE = &H56
    Private Const SPI_SETCURSORS = &H57
    Private Const SPI_SETICONS = &H58
    Private Const SPI_GETDEFAULTINPUTLANG = &H59
    Private Const SPI_SETDEFAULTINPUTLANG = &H5A
    Private Const SPI_SETLANGTOGGLE = &H5B
    Private Const SPI_GETWINDOWSEXTENSION = &H5C
    Private Const SPI_SETMOUSETRAILS = &H5D
    Private Const SPI_GETMOUSETRAILS = &H5E
    Private Const SPI_SETSCREENSAVERRUNNING = &H61
    Private Const SPI_SCREENSAVERRUNNING = SPI_SETSCREENSAVERRUNNING
    Private Const SPI_GETFILTERKEYS = &H32
    Private Const SPI_SETFILTERKEYS = &H33
    Private Const SPI_GETTOGGLEKEYS = &H34
    Private Const SPI_SETTOGGLEKEYS = &H35
    Private Const SPI_GETMOUSEKEYS = &H36
    Private Const SPI_SETMOUSEKEYS = &H37
    Private Const SPI_GETSHOWSOUNDS = &H38
    Private Const SPI_SETSHOWSOUNDS = &H39
    Private Const SPI_GETSTICKYKEYS = &H3A
    Private Const SPI_SETSTICKYKEYS = &H3B
    Private Const SPI_GETACCESSTIMEOUT = &H3C
    Private Const SPI_SETACCESSTIMEOUT = &H3D
    Private Const SPI_GETSERIALKEYS = &H3E
    Private Const SPI_SETSERIALKEYS = &H3F
    Private Const SPI_GETSOUNDSENTRY = &H40
    Private Const SPI_SETSOUNDSENTRY = &H41
    Private Const SPI_GETSNAPTODEFBUTTON = &H5F
    Private Const SPI_SETSNAPTODEFBUTTON = &H60
    Private Const SPI_GETMOUSEHOVERWIDTH = &H62
    Private Const SPI_SETMOUSEHOVERWIDTH = &H63
    Private Const SPI_GETMOUSEHOVERHEIGHT = &H64
    Private Const SPI_SETMOUSEHOVERHEIGHT = &H65
    Private Const SPI_GETMOUSEHOVERTIME = &H66
    Private Const SPI_SETMOUSEHOVERTIME = &H67
    Private Const SPI_GETWHEELSCROLLLINES = &H68
    Private Const SPI_SETWHEELSCROLLLINES = &H69
    Private Const SPI_GETMENUSHOWDELAY = &H6A
    Private Const SPI_SETMENUSHOWDELAY = &H6B
    Private Const SPI_GETSHOWIMEUI = &H6E
    Private Const SPI_SETSHOWIMEUI = &H6F
    Private Const SPI_GETMOUSESPEED = &H70
    Private Const SPI_SETMOUSESPEED = &H71
    Private Const SPI_GETSCREENSAVERRUNNING = &H72
    Private Const SPI_GETDESKWALLPAPER = &H73
    Private Const SPI_GETACTIVEWINDOWTRACKING = &H1000
    Private Const SPI_SETACTIVEWINDOWTRACKING = &H1001
    Private Const SPI_GETMENUANIMATION = &H1002
    Private Const SPI_SETMENUANIMATION = &H1003
    Private Const SPI_GETCOMBOBOXANIMATION = &H1004
    Private Const SPI_SETCOMBOBOXANIMATION = &H1005
    Private Const SPI_GETLISTBOXSMOOTHSCROLLING = &H1006
    Private Const SPI_SETLISTBOXSMOOTHSCROLLING = &H1007
    Private Const SPI_GETGRADIENTCAPTIONS = &H1008
    Private Const SPI_SETGRADIENTCAPTIONS = &H1009
    Private Const SPI_GETKEYBOARDCUES = &H100A
    Private Const SPI_SETKEYBOARDCUES = &H100B
    Private Const SPI_GETMENUUNDERLINES = SPI_GETKEYBOARDCUES
    Private Const SPI_SETMENUUNDERLINES = SPI_SETKEYBOARDCUES
    Private Const SPI_GETACTIVEWNDTRKZORDER = &H100C
    Private Const SPI_SETACTIVEWNDTRKZORDER = &H100D
    Private Const SPI_GETHOTTRACKING = &H100E
    Private Const SPI_SETHOTTRACKING = &H100F
    Private Const SPI_GETMENUFADE = &H1012
    Private Const SPI_SETMENUFADE = &H1013
    Private Const SPI_GETSELECTIONFADE = &H1014
    Private Const SPI_SETSELECTIONFADE = &H1015
    Private Const SPI_GETTOOLTIPANIMATION = &H1016
    Private Const SPI_SETTOOLTIPANIMATION = &H1017
    Private Const SPI_GETTOOLTIPFADE = &H1018
    Private Const SPI_SETTOOLTIPFADE = &H1019
    Private Const SPI_GETCURSORSHADOW = &H101A
    Private Const SPI_SETCURSORSHADOW = &H101B
    Private Const SPI_GETMOUSESONAR = &H101C
    Private Const SPI_SETMOUSESONAR = &H101D
    Private Const SPI_GETMOUSECLICKLOCK = &H101E
    Private Const SPI_SETMOUSECLICKLOCK = &H101F
    Private Const SPI_GETMOUSEVANISH = &H1020
    Private Const SPI_SETMOUSEVANISH = &H1021
    Private Const SPI_GETFLATMENU = &H1022
    Private Const SPI_SETFLATMENU = &H1023
    Private Const SPI_GETDROPSHADOW = &H1024
    Private Const SPI_SETDROPSHADOW = &H1025
    Private Const SPI_GETBLOCKSENDINPUTRESETS = &H1026
    Private Const SPI_SETBLOCKSENDINPUTRESETS = &H1027
    Private Const SPI_GETUIEFFECTS = &H103E
    Private Const SPI_SETUIEFFECTS = &H103F
    Private Const SPI_GETFOREGROUNDLOCKTIMEOUT = &H2000
    Private Const SPI_SETFOREGROUNDLOCKTIMEOUT = &H2001
    Private Const SPI_GETACTIVEWNDTRKTIMEOUT = &H2002
    Private Const SPI_SETACTIVEWNDTRKTIMEOUT = &H2003
    Private Const SPI_GETFOREGROUNDFLASHCOUNT = &H2004
    Private Const SPI_SETFOREGROUNDFLASHCOUNT = &H2005
    Private Const SPI_GETCARETWIDTH = &H2006
    Private Const SPI_SETCARETWIDTH = &H2007
    Private Const SPI_GETMOUSECLICKLOCKTIME = &H2008
    Private Const SPI_SETMOUSECLICKLOCKTIME = &H2009
    Private Const SPI_GETFONTSMOOTHINGTYPE = &H200A
    Private Const SPI_SETFONTSMOOTHINGTYPE = &H200B
    Private Const SPI_GETFONTSMOOTHINGCONTRAST = &H200C
    Private Const SPI_SETFONTSMOOTHINGCONTRAST = &H200D
    Private Const SPI_GETFOCUSBORDERWIDTH = &H200E
    Private Const SPI_SETFOCUSBORDERWIDTH = &H200F
    Private Const SPI_GETFOCUSBORDERHEIGHT = &H2010
    Private Const SPI_SETFOCUSBORDERHEIGHT = &H2011
    Private Const SPI_GETFONTSMOOTHINGORIENTATION = &H2012
    Private Const SPI_SETFONTSMOOTHINGORIENTATION = &H2013
    Private Const SPIF_UPDATEINIFILE = &H1
    Private Const SPIF_SENDWININICHANGE = &H2
    Private Const SPIF_SENDCHANGE = SPIF_SENDWININICHANGE
  #End If
  Private Const SPI_GETWORKAREA = &H30


  ' local UDTs

  Private Type DEVNAMES
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
  End Type

  Private Type DEVMODE
    dmDeviceName As String * 32
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * 32
    dmUnusedPadding As Integer
    dmBitsPerPel As Long
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
    dmICMMethod As Long
    dmICMIntent As Long
    dmMediaType As Long
    dmDitherType As Long
    dmReserved1 As Long
    dmReserved2 As Long
    dmPanningWidth As Long
    dmPanningHeight As Long
  End Type

  Private Type POINTAPI
    X As Long
    Y As Long
  End Type

  Private Type PRINTPAGERANGE
    nFromPage As Long
    nToPage As Long
  End Type

  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Private Type TPAGESETUPDLG
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    Flags As Long
    ptPaperSize As POINTAPI
    rtMinMargin As RECT
    rtMargin As RECT
    hInstance As Long
    lCustData As Long
    lpfnPageSetupHook As Long
    lpfnPagePaintHook As Long
    lpPageSetupTemplateName As String
    hPageSetupTemplate As Long
  End Type

  Private Type TPRINTDLG
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    Flags As CDPrintDialogFlags
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    ' right, now we have serious alignment problems.
    ' We're two bytes off for the next 8 fields...
    b(0 To 31) As Byte
    'hInstance As Long              '  0 - 3
    'lCustData As Long              '  4 - 7
    'lpfnPrintHook As Long          '  8 - 11
    'lpfnSetupHook As Long          ' 12 - 15
    'lpPrintTemplateName As Long    ' 16 - 19
    'lpSetupTemplateName As Long    ' 20 - 23
    'hPrintTemplate As Long         ' 24 - 27
    'hSetupTemplate As Long         ' 28 - 31
  End Type

  Private Type TPRINTDLGEXA
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    Flags As CDPrintDialogFlags
    Flags2 As Long               ' reserved
    ExclusionFlags As Long
    nPageRanges As Long
    nMaxPageRanges As Long
    lpPageRanges As Long         ' array of PRINTPAGERANGEs
    nMinPage As Long
    nMaxPage As Long
    nCopies As Long
    hInstance As Long
    lpPrintTemplateName As Long
    lpCallback As Long
    nPropertyPages As Long
    lphPropertyPages As Long     ' array of PROPSHEETPAGE handles
    nStartPage As Long
    dwResultAction As Long
  End Type


  ' local vars

  Private colRanges As Collection
  Private mASM() As Byte


  ' vars used to store the values of public properties

  Private propCopies As Integer
  Private propDeviceName As String
  Private propDriverName As String
  Private propDuplex As CDDuplexConsts
  Private propExclusionFlags As CDPrintDialogExclusionFlags
  Private prophWndParent As Long
  Private propICM As CDICMConsts
  Private propICMMode As CDICMModeConsts
  Private propInitDeviceData As Boolean
  Private propMaxPage As Long
  Private propMediaType As CDMediaTypeConsts
  Private propMinPage As Long
  Private propMinPageBorderBottom As Long
  Private propMinPageBorderLeft As Long
  Private propMinPageBorderRight As Long
  Private propMinPageBorderTop As Long
  Private propMonochrome As Boolean
  Private propOrientation As CDOrientationConsts
  Private propOutputName As String
  Private propPageBorderBottom As Long
  Private propPageBorderLeft As Long
  Private propPageBorderRight As Long
  Private propPageBorderTop As Long
  Private propPageSetupFlags As CDPageSetupFlags
  Private propPaperLength As Long
  Private propPaperSize As CDPaperSizeConsts
  Private propPaperSizeName As String
  Private propPaperSource As CDPaperSourceConsts
  Private propPaperWidth As Long
  Private propPrintDlgFlags As CDPrintDialogFlags
  Private propPrinterhDC As Long
  Private propPrintQuality As CDPrintQualityConsts
  Private propSort As Boolean
  Private propTrueTypeMode As CDTrueTypeConsts
  Private propxResolution As Integer
  Private propyResolution As Integer
  Private propZoomPercent As Integer


  ' local API-declarations

  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Ziel As Any, Quelle As Any, ByVal Size As Long)
  Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
  Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, rc As RECT) As Long
  Private Declare Function GlobalAlloc Lib "kernel32" (ByVal Flags As Long, ByVal Size As Long) As Long
  Private Declare Function GlobalFree Lib "kernel32" (ByVal hMemory As Long) As Long
  Private Declare Function GlobalLock Lib "kernel32" (ByVal hMemory As Long) As Long
  Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMemory As Long) As Long
  Private Declare Function lstrlen_AsLong Lib "kernel32" Alias "lstrlenA" (ByVal pString As Long) As Long
  Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal Repaint As Long) As Long
  Private Declare Function PageSetupDlg Lib "comdlg32" Alias "PageSetupDlgA" (Data As TPAGESETUPDLG) As Long
  Private Declare Function PrintDlg Lib "comdlg32" Alias "PrintDlgA" (Data As TPRINTDLG) As Long
  Private Declare Function PrintDlgEx Lib "comdlg32" Alias "PrintDlgExA" (Data As TPRINTDLGEXA) As Long
  Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal ParamInfo As Long, ByVal ParamData1 As Long, ParamData2 As Any, ByVal Flags As Long) As Long


' events

Private Sub Class_Initialize()
  Dim ptr As Long

  ' get the VTable-Ptr
  CopyMemory ptr, ByVal ObjPtr(Me), LenB(ptr)
  ' get the pointer to the first public procedure (must be our WinMain)
  CopyMemory ptr, ByVal ptr + &H1C, LenB(ptr)
  ReDim mASM(0 To 42) As Byte     ' bytes 38 to 42 will receive the return value of our WinMain
  ' lay the frame pointer onto the stack (what for?)
  mASM(0) = &H55     ' PUSH EBP
  ' get the stack pointer into EBP
  CopyMemory mASM(1), &H68EC8B, 3     ' MOV EBP, ESP
  ' lay the offset of the return value's address onto the stack
  CopyMemory mASM(4), VarPtr(mASM(39)), 4   ' PUSH dword ptr [offset of return address]

  ' lay the addresses of the WinMain's arguments onto the stack
  ' 4th argument
  CopyMemory mASM(8), &H1475FF, 3     ' PUSH dword ptr [EBP+14h]
  ' 3rd argument
  CopyMemory mASM(11), &H1075FF, 3     ' PUSH dword ptr [EBP+10h]
  ' 2nd argument
  CopyMemory mASM(14), &HC75FF, 3     ' PUSH dword ptr [EBP+0Ch]
  ' 1st argument
  CopyMemory mASM(17), &H875FF, 3     ' PUSH dword ptr [EBP+08h]

  ' lay the current object's pointer onto the stack
  mASM(20) = &H68     ' PUSH 32-bit-immediate
  CopyMemory mASM(21), ObjPtr(Me), 4     ' the immediate
  ' call our WinMain
  mASM(25) = &HE8     ' CALL 32-bit relative code address
  CopyMemory mASM(26), ptr - VarPtr(mASM(30)), 4    ' the relative address
  ' move the WinMain's return value into EAX
  mASM(30) = &HA1     ' MOV EAX, dword ptr [offset of return address]
  CopyMemory mASM(31), VarPtr(mASM(39)), 4     ' the offset
  ' leave our WinMain
  mASM(35) = &HC9     ' LEAVE
  ' return from our WinMain
  mASM(36) = &HC2     ' RET 10h     (seems to be some offset - it's the size of all arguments together)
  CopyMemory mASM(37), &H10, 2    ' can't do the "RET 10h" in 1 line - probably alignment problems

  Set colRanges = New Collection
End Sub

Private Sub Class_Terminate()
  Set colRanges = Nothing
End Sub


' This must be the first public method!!
' disadvantage of the Assembler trick: we now have 1 method for all dialogs
Public Function GenericHookProc(ByVal hDlg As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Const WM_INITDIALOG = &H110
  Dim hWnd As Long
  Dim rc As RECT
  Dim rc2 As RECT
  Dim X As Long
  Dim Y As Long

  Select Case msg
    Case WM_INITDIALOG
      hWnd = GetParent(hDlg)
      GetWindowRect hWnd, rc
      If SystemParametersInfo(SPI_GETWORKAREA, 0, rc2, 0) = 0 Then
        ' call failed - just use standard screen:
        rc2.Left = 0
        rc2.Top = 0
        rc2.Right = Screen.Width \ Screen.TwipsPerPixelX
        rc2.Bottom = Screen.Height \ Screen.TwipsPerPixelY
      End If
      If (rc.Right > 0) And (rc.Bottom > 0) Then
        X = rc2.Left + (((rc2.Right - rc2.Left) - (rc.Right - rc.Left)) \ 2)
        Y = rc2.Top + (((rc2.Bottom - rc2.Top) - (rc.Bottom - rc.Top)) \ 2)
        MoveWindow hWnd, X, Y, rc.Right - rc.Left, rc.Bottom - rc.Top, 1
      End If
  End Select
End Function


' public properties

Public Property Get Copies() As Integer
  Copies = propCopies
End Property

Public Property Let Copies(ByVal New_Copies As Integer)
  propCopies = New_Copies
End Property

Public Property Get DeviceName() As String
  DeviceName = propDeviceName
End Property

Public Property Let DeviceName(ByVal New_DeviceName As String)
  propDeviceName = New_DeviceName
End Property

Public Property Get DriverName() As String
  DriverName = propDriverName
End Property
'
'Public Property Let DriverName(ByVal New_DriverName As String)
'  propDriverName = New_DriverName
'End Property

Public Property Get Duplex() As CDDuplexConsts
  Duplex = propDuplex
End Property

Public Property Let Duplex(ByVal New_Duplex As CDDuplexConsts)
  propDuplex = New_Duplex
End Property

Public Property Get ExclusionFlags() As CDPrintDialogExclusionFlags
  ExclusionFlags = propExclusionFlags
End Property

Public Property Let ExclusionFlags(ByVal New_ExclusionFlags As CDPrintDialogExclusionFlags)
  propExclusionFlags = New_ExclusionFlags
End Property

Public Property Get hWndParent() As Long
  hWndParent = prophWndParent
End Property

Public Property Let hWndParent(ByVal New_hWndParent As Long)
  prophWndParent = New_hWndParent
End Property

Public Property Get ICM() As CDICMConsts
  ICM = propICM
End Property

Public Property Let ICM(ByVal New_ICM As CDICMConsts)
  propICM = New_ICM
End Property

Public Property Get ICMMode() As CDICMModeConsts
  ICMMode = propICMMode
End Property

Public Property Let ICMMode(ByVal New_ICMMode As CDICMModeConsts)
  propICMMode = New_ICMMode
End Property

Public Property Get InitDeviceData() As Boolean
  InitDeviceData = propInitDeviceData
End Property

Public Property Let InitDeviceData(ByVal New_InitDeviceData As Boolean)
  propInitDeviceData = New_InitDeviceData
End Property

Public Property Get MaxPage() As Long
  MaxPage = propMaxPage
End Property

Public Property Let MaxPage(ByVal New_MaxPage As Long)
  propMaxPage = New_MaxPage
End Property

Public Property Get MediaType() As CDMediaTypeConsts
  MediaType = propMediaType
End Property

Public Property Let MediaType(ByVal New_MediaType As CDMediaTypeConsts)
  propMediaType = New_MediaType
End Property

Public Property Get MinPage() As Long
  MinPage = propMinPage
End Property

Public Property Let MinPage(ByVal New_MinPage As Long)
  propMinPage = New_MinPage
End Property

Public Property Get MinPageBorderBottom() As Long
  MinPageBorderBottom = propMinPageBorderBottom / 100
End Property

Public Property Let MinPageBorderBottom(ByVal New_MinPageBorderBottom As Long)
  propMinPageBorderBottom = New_MinPageBorderBottom * 100
End Property

Public Property Get MinPageBorderLeft() As Long
  MinPageBorderLeft = propMinPageBorderLeft / 100
End Property

Public Property Let MinPageBorderLeft(ByVal New_MinPageBorderLeft As Long)
  propMinPageBorderLeft = New_MinPageBorderLeft * 100
End Property

Public Property Get MinPageBorderRight() As Long
  MinPageBorderRight = propMinPageBorderRight / 100
End Property

Public Property Let MinPageBorderRight(ByVal New_MinPageBorderRight As Long)
  propMinPageBorderRight = New_MinPageBorderRight * 100
End Property

Public Property Get MinPageBorderTop() As Long
  MinPageBorderTop = propMinPageBorderTop / 100
End Property

Public Property Let MinPageBorderTop(ByVal New_MinPageBorderTop As Long)
  propMinPageBorderTop = New_MinPageBorderTop * 100
End Property

Public Property Get Monochrome() As Boolean
  Monochrome = propMonochrome
End Property

Public Property Let Monochrome(ByVal New_Monochrome As Boolean)
  propMonochrome = New_Monochrome
End Property

Public Property Get Orientation() As CDOrientationConsts
  Orientation = propOrientation
End Property

Public Property Let Orientation(ByVal New_Orientation As CDOrientationConsts)
  propOrientation = New_Orientation
End Property

Public Property Get OutputName() As String
  OutputName = propOutputName
End Property
'
'Public Property Let OutputName(ByVal New_OutputName As String)
'  propOutputName = New_OutputName
'End Property

Public Property Get PageBorderBottom() As Long
  PageBorderBottom = propPageBorderBottom / 100
End Property

Public Property Let PageBorderBottom(ByVal New_PageBorderBottom As Long)
  propPageBorderBottom = New_PageBorderBottom * 100
End Property

Public Property Get PageBorderLeft() As Long
  PageBorderLeft = propPageBorderLeft / 100
End Property

Public Property Let PageBorderLeft(ByVal New_PageBorderLeft As Long)
  propPageBorderLeft = New_PageBorderLeft * 100
End Property

Public Property Get PageBorderRight() As Long
  PageBorderRight = propPageBorderRight / 100
End Property

Public Property Let PageBorderRight(ByVal New_PageBorderRight As Long)
  propPageBorderRight = New_PageBorderRight * 100
End Property

Public Property Get PageBorderTop() As Long
  PageBorderTop = propPageBorderTop / 100
End Property

Public Property Let PageBorderTop(ByVal New_PageBorderTop As Long)
  propPageBorderTop = New_PageBorderTop * 100
End Property

Public Property Get PageSetupFlags() As CDPageSetupFlags
  PageSetupFlags = propPageSetupFlags
End Property

Public Property Let PageSetupFlags(ByVal New_PageSetupFlags As CDPageSetupFlags)
  propPageSetupFlags = New_PageSetupFlags
End Property

Public Property Get PaperLength() As Long
  PaperLength = propPaperLength / 100
End Property

Public Property Let PaperLength(ByVal New_PaperLength As Long)
  propPaperLength = New_PaperLength * 10
End Property

Public Property Get PaperSize() As CDPaperSizeConsts
  PaperSize = propPaperSize
End Property

Public Property Get PaperSizeName() As String
  PaperSizeName = propPaperSizeName
End Property

Public Property Let PaperSize(ByVal New_PaperSize As CDPaperSizeConsts)
  propPaperSize = New_PaperSize
End Property

Public Property Get PaperSource() As CDPaperSourceConsts
  PaperSource = propPaperSource
End Property

Public Property Let PaperSource(ByVal New_PaperSource As CDPaperSourceConsts)
  propPaperSource = New_PaperSource
End Property

Public Property Get PaperWidth() As Long
  PaperWidth = propPaperWidth / 100
End Property

Public Property Let PaperWidth(ByVal New_PaperWidth As Long)
  propPaperWidth = New_PaperWidth * 10
End Property

Public Property Get PrintDlgFlags() As CDPrintDialogFlags
  PrintDlgFlags = propPrintDlgFlags
End Property

Public Property Let PrintDlgFlags(ByVal New_PrintDlgFlags As CDPrintDialogFlags)
  If propSort Then
    New_PrintDlgFlags = New_PrintDlgFlags Or CDPrintDialogFlags.PD_COLLATE
  Else
    New_PrintDlgFlags = New_PrintDlgFlags And Not CDPrintDialogFlags.PD_COLLATE
  End If

  propPrintDlgFlags = New_PrintDlgFlags
End Property

Public Property Get PrinterhDC() As Long
  PrinterhDC = propPrinterhDC
End Property

Public Property Let PrinterhDC(ByVal New_PrinterhDC As Long)
  propPrinterhDC = New_PrinterhDC
End Property

Public Property Get PrintQuality() As CDPrintQualityConsts
  PrintQuality = propPrintQuality
End Property

Public Property Let PrintQuality(ByVal New_PrintQuality As CDPrintQualityConsts)
  propPrintQuality = New_PrintQuality
End Property

Public Property Get RangeCount() As Integer
  RangeCount = colRanges.Count / 2
End Property

Public Property Get RangeFromPage(ByVal iRange As Integer) As String
  If Not isValidNumber(iRange, 1, Me.RangeCount) Then
    Err.Raise 9
    Exit Property
  End If

  RangeFromPage = colRanges(iRange * 2 - 1)
End Property

Public Property Get RangeToPage(ByVal iRange As Integer) As String
  If Not isValidNumber(iRange, 1, Me.RangeCount) Then
    Err.Raise 9
    Exit Property
  End If

  RangeToPage = colRanges(iRange * 2)
End Property

Public Property Get Sort() As Boolean
  Sort = propSort
End Property

Public Property Let Sort(ByVal New_Sort As Boolean)
  If New_Sort Then
    propPrintDlgFlags = propPrintDlgFlags Or CDPrintDialogFlags.PD_COLLATE
  Else
    propPrintDlgFlags = propPrintDlgFlags And Not CDPrintDialogFlags.PD_COLLATE
  End If

  propSort = New_Sort
End Property

Public Property Get TrueTypeMode() As CDTrueTypeConsts
  TrueTypeMode = propTrueTypeMode
End Property

Public Property Let TrueTypeMode(ByVal New_TrueTypeMode As CDTrueTypeConsts)
  propTrueTypeMode = New_TrueTypeMode
End Property

Public Property Get xResolution() As Integer
  xResolution = propxResolution
End Property

Public Property Let xResolution(ByVal New_xResolution As Integer)
  propxResolution = New_xResolution
End Property

Public Property Get yResolution() As Integer
  yResolution = propyResolution
End Property

Public Property Let yResolution(ByVal New_yResolution As Integer)
  propyResolution = New_yResolution
End Property

Public Property Get ZoomPercent() As Integer
  ZoomPercent = propZoomPercent
End Property

Public Property Let ZoomPercent(ByVal New_ZoomPercent As Integer)
  propZoomPercent = New_ZoomPercent
End Property


' local methods

Private Function getDevNameString(ByVal pDevNames As Long, ByVal pOffset As Long) As String
  Dim b() As Byte
  Dim ret As String
  Dim StringLength As Long

  StringLength = lstrlen_AsLong(pDevNames + pOffset)
  If StringLength > 0 Then
    ReDim b(0 To StringLength - 1) As Byte
    CopyMemory b(0), ByVal pDevNames + pOffset, StringLength
    ret = StrConv(b, VbStrConv.vbUnicode)
  End If

  getDevNameString = ret
End Function

Private Function isArrayEmpty(Arr As Variant) As Boolean
  Dim tmp As Long

  On Error Resume Next
  tmp = LBound(Arr)
  isArrayEmpty = Err
End Function

' checks whether <txt> is a valid number between <LoBound> and <HiBound>
Private Function isValidNumber(ByVal txt As String, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  Dim i As Integer
  Dim ret As Boolean
  Dim tmp As String

  If txt = "" Then Exit Function

  ret = True

  tmp = txt
  If Left(tmp, 1) = "-" Then tmp = Mid(tmp, 2)

  ' we need to check every single char
  For i = 1 To Len(tmp)
    If InStr("0123456789", Mid(tmp, i, 1)) = 0 Then ret = False
  Next
  If ret Then
    ' check the bounds
    ret = isWithinRange(CLng(txt), LoBound, HiBound)
  End If

  isValidNumber = ret
End Function

' checks whether <Num> is placed between <LoBound> and <HiBound>
Private Function isWithinRange(ByVal Num As Long, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  isWithinRange = ((Num >= LoBound) And (Num <= HiBound))
End Function

' cuts <txt> at the first occurance of Chr(0)
Private Function removeNull(ByVal txt As String) As String
  Dim pos As Integer

  pos = InStr(txt, Chr(0))
  If pos Then txt = Left(txt, pos - 1)
  removeNull = txt
End Function


' public methods

' adds a range
Public Sub AddRange(ByVal FromPage As Long, ByVal ToPage As Long, Optional ByVal After As Integer = -1)
  If After > 0 Then
    colRanges.Add FromPage, , , After * 2
    colRanges.Add ToPage, , , After * 2 + 1
  Else
    colRanges.Add FromPage
    colRanges.Add ToPage
  End If
End Sub

' removes all ranges
Public Sub RemoveAllRanges()
  Set colRanges = New Collection
End Sub

' removes the range <iRange>
Public Sub RemoveRange(ByVal iRange As Integer)
  ' remove ToPage
  colRanges.Remove iRange * 2
  ' remove FromPage
  colRanges.Remove iRange * 2 - 1
End Sub

' pops up a "Setup page..."-dialog
Public Function showPageSetup() As Boolean
  Const DMCOLOR_COLOR = 2
  Const DMCOLOR_MONOCHROME = 1
  Const GMEM_FIXED = &H0
  Const GMEM_ZEROINIT = &H40
  Dim Data As TPAGESETUPDLG
  Dim DevModeData As DEVMODE
  Dim Fields As CDFields
  Dim hDevMode As Long
  Dim pDevNames As Long
  Dim phDevMode As Long
  Dim ret As Boolean
  Dim tDevNames As DEVNAMES

  ' prepare the API call
  If propInitDeviceData Then
    With DevModeData
      .dmSize = LenB(DevModeData)
      .dmCollate = Abs(propSort)
      .dmColor = IIf(propMonochrome, DMCOLOR_MONOCHROME, DMCOLOR_COLOR)
      .dmCopies = propCopies
      .dmDefaultSource = propPaperSource
      .dmDeviceName = propDeviceName & Chr(0)
      .dmDuplex = propDuplex
      Fields = CDFields.DM_COLLATE Or CDFields.DM_COLOR Or CDFields.DM_COPIES Or CDFields.DM_DEFAULTSOURCE Or CDFields.DM_DUPLEX Or CDFields.DM_ICMINTENT Or CDFields.DM_ICMMETHOD Or CDFields.DM_MEDIATYPE Or CDFields.DM_ORIENTATION Or CDFields.DM_PAPERLENGTH Or CDFields.DM_PAPERSIZE Or CDFields.DM_PAPERWIDTH Or CDFields.DM_PRINTQUALITY Or CDFields.DM_SCALE Or CDFields.DM_TTOPTION Or CDFields.DM_YRESOLUTION
      .dmFields = Fields
      .dmICMIntent = propICMMode
      .dmICMMethod = propICM
      .dmMediaType = propMediaType
      .dmOrientation = propOrientation
      .dmPaperLength = propPaperLength
      .dmPaperSize = propPaperSize
      .dmPaperWidth = propPaperWidth
      .dmPrintQuality = IIf(propxResolution > 0, propxResolution, propPrintQuality)
      .dmScale = propZoomPercent
      .dmTTOption = propTrueTypeMode
      .dmYResolution = propyResolution
    End With

    hDevMode = GlobalAlloc(GMEM_ZEROINIT Or GMEM_FIXED, LenB(DevModeData))
    phDevMode = GlobalLock(hDevMode)
    CopyMemory ByVal phDevMode, DevModeData, LenB(DevModeData)
  End If

  ' ToDo: implement setting hDevNames

  With Data
    .Flags = propPageSetupFlags Or CDPageSetupFlags.PSD_INHUNDREDTHSOFMILLIMETERS
    .hDevMode = hDevMode
    .hInstance = App.hInstance
    .hwndOwner = prophWndParent
    With .rtMargin
      .Bottom = propPageBorderBottom
      .Left = propPageBorderLeft
      .Right = propPageBorderRight
      .Top = propPageBorderTop
    End With
    With .rtMinMargin
      .Bottom = propMinPageBorderBottom
      .Left = propMinPageBorderLeft
      .Right = propMinPageBorderRight
      .Top = propMinPageBorderTop
    End With
    #If UseHooking Then
      ' ToDo: doesn't seem to work
      .Flags = .Flags Or CDPageSetupFlags.PSD_ENABLEPAGESETUPHOOK
      .lpfnPageSetupHook = VarPtr(mASM(0))
    #End If
    .lStructSize = LenB(Data)
  End With

  ' show up the dialog
  ret = PageSetupDlg(Data)

  ' free the memory we used
  If hDevMode Then GlobalFree hDevMode

  If Data.hDevMode Then
    phDevMode = GlobalLock(Data.hDevMode)
    CopyMemory DevModeData, ByVal phDevMode, LenB(DevModeData)
    GlobalUnlock Data.hDevMode
  End If
  If ret Then
    ' return the selected settings
    With DevModeData
      propCopies = .dmCopies
      propDuplex = .dmDuplex
      propICM = .dmICMMethod
      propICMMode = .dmICMIntent
      propMediaType = .dmMediaType
      propMonochrome = .dmColor = DMCOLOR_MONOCHROME
      propOrientation = .dmOrientation
      propPaperLength = .dmPaperLength
      propPaperSize = .dmPaperSize
      propPaperSizeName = removeNull(.dmFormName)
      propPaperSource = .dmDefaultSource
      propPaperWidth = .dmPaperWidth
      propPrintQuality = .dmPrintQuality
      propSort = .dmCollate
      propTrueTypeMode = .dmTTOption
      propxResolution = .dmPrintQuality
      propyResolution = .dmYResolution
      propZoomPercent = .dmScale
    End With
    With Data
      If .hDevNames Then
        pDevNames = GlobalLock(.hDevNames)
        CopyMemory tDevNames, ByVal pDevNames, Len(tDevNames)
        propDriverName = getDevNameString(pDevNames, tDevNames.wDriverOffset)
        propDeviceName = getDevNameString(pDevNames, tDevNames.wDeviceOffset)
        propOutputName = getDevNameString(pDevNames, tDevNames.wOutputOffset)
        GlobalUnlock .hDevNames
      End If

      With .rtMargin
        propPageBorderBottom = .Bottom
        propPageBorderLeft = .Left
        propPageBorderRight = .Right
        propPageBorderTop = .Top
      End With
    End With
  End If

  showPageSetup = ret
End Function

' pops up an "Choose printer..."-dialog and returns the selected printer
Public Function showPrinter() As Boolean
  Const DMCOLOR_COLOR = 2
  Const DMCOLOR_MONOCHROME = 1
  Const GMEM_FIXED = &H0
  Const GMEM_ZEROINIT = &H40
  Dim Data As TPRINTDLG
  Dim DevModeData As DEVMODE
  Dim Fields As CDFields
  Dim hDevMode As Long
  Dim pDevNames As Long
  Dim phDevMode As Long
  Dim ret As Boolean
  Dim tDevNames As DEVNAMES

  ' prepare the API call
  If propInitDeviceData Then
    With DevModeData
      .dmSize = LenB(DevModeData)
      .dmCollate = Abs(propSort)
      .dmColor = IIf(propMonochrome, DMCOLOR_MONOCHROME, DMCOLOR_COLOR)
      .dmCopies = propCopies
      .dmDefaultSource = propPaperSource
      .dmDeviceName = propDeviceName & Chr(0)
      .dmDuplex = propDuplex
      Fields = CDFields.DM_COLLATE Or CDFields.DM_COLOR Or CDFields.DM_COPIES Or CDFields.DM_DEFAULTSOURCE Or CDFields.DM_DUPLEX Or CDFields.DM_ICMINTENT Or CDFields.DM_ICMMETHOD Or CDFields.DM_MEDIATYPE Or CDFields.DM_ORIENTATION Or CDFields.DM_PAPERLENGTH Or CDFields.DM_PAPERSIZE Or CDFields.DM_PAPERWIDTH Or CDFields.DM_PRINTQUALITY Or CDFields.DM_SCALE Or CDFields.DM_TTOPTION Or CDFields.DM_YRESOLUTION
      .dmFields = Fields
      .dmICMIntent = propICMMode
      .dmICMMethod = propICM
      .dmMediaType = propMediaType
      .dmOrientation = propOrientation
      .dmPaperLength = propPaperLength
      .dmPaperSize = propPaperSize
      .dmPaperWidth = propPaperWidth
      .dmPrintQuality = IIf(propxResolution > 0, propxResolution, propPrintQuality)
      .dmScale = propZoomPercent
      .dmTTOption = propTrueTypeMode
      .dmYResolution = propyResolution
    End With

    hDevMode = GlobalAlloc(GMEM_ZEROINIT Or GMEM_FIXED, LenB(DevModeData))
    phDevMode = GlobalLock(hDevMode)
    CopyMemory ByVal phDevMode, DevModeData, LenB(DevModeData)
  End If

  ' ToDo: implement setting hDevNames

  With Data
    .Flags = propPrintDlgFlags
    CopyMemory .b(0), App.hInstance, 4
    .hwndOwner = prophWndParent
    .hDevMode = hDevMode
    .nCopies = propCopies
    .nMaxPage = propMaxPage
    .nMinPage = propMinPage
    .nFromPage = colRanges(1)
    .nToPage = colRanges(2)
    #If UseHooking Then
      ' ToDo: doesn't seem to work
      .Flags = .Flags Or CDPrintDialogFlags.PD_ENABLEPRINTHOOK Or CDPrintDialogFlags.PD_ENABLESETUPHOOK
      CopyMemory .b(8), VarPtr(mASM(0)), 4
      CopyMemory .b(12), VarPtr(mASM(0)), 4
    #End If
    .lStructSize = Len(Data)
  End With

  ' show up the dialog
  ret = (PrintDlg(Data) = 1)

  ' free the memory we used
  If hDevMode Then GlobalFree hDevMode

  If Data.hDevMode Then
    phDevMode = GlobalLock(Data.hDevMode)
    CopyMemory DevModeData, ByVal phDevMode, LenB(DevModeData)
    GlobalUnlock Data.hDevMode
  End If
  If ret Then
    ' return the selected printer
    With DevModeData
      propCopies = .dmCopies
      propDuplex = .dmDuplex
      propICM = .dmICMMethod
      propICMMode = .dmICMIntent
      propMediaType = .dmMediaType
      propMonochrome = .dmColor = DMCOLOR_MONOCHROME
      propOrientation = .dmOrientation
      propPaperLength = .dmPaperLength
      propPaperSize = .dmPaperSize
      propPaperSizeName = removeNull(.dmFormName)
      propPaperSource = .dmDefaultSource
      propPaperWidth = .dmPaperWidth
      propPrintQuality = .dmPrintQuality
      propSort = .dmCollate
      propTrueTypeMode = .dmTTOption
      propxResolution = .dmPrintQuality
      propyResolution = .dmYResolution
      propZoomPercent = .dmScale
    End With
    With Data
      If .hDevNames Then
        pDevNames = GlobalLock(.hDevNames)
        CopyMemory tDevNames, ByVal pDevNames, Len(tDevNames)
        propDriverName = getDevNameString(pDevNames, tDevNames.wDriverOffset)
        propDeviceName = getDevNameString(pDevNames, tDevNames.wDeviceOffset)
        propOutputName = getDevNameString(pDevNames, tDevNames.wOutputOffset)
        GlobalUnlock .hDevNames
      End If

      propCopies = .nCopies
      Me.RemoveAllRanges
      Me.AddRange .nFromPage, .nToPage
      propPrintDlgFlags = .Flags
      propPrinterhDC = .hDC
      propSort = .Flags And PD_COLLATE
    End With
  End If

  showPrinter = ret
End Function

' pops up an "Choose printer..."-dialog and returns the selected printer
Public Function showPrinterEx(Optional ByVal iInitialPropPage As Long = START_PAGE_GENERAL, Optional ByVal arrAdditionalPropertyPages As Variant) As CDPrintDlgExResultActionIDs
  Const DMCOLOR_COLOR = 2
  Const DMCOLOR_MONOCHROME = 1
  Const GMEM_FIXED = &H0
  Const GMEM_ZEROINIT = &H40
  Dim Data As TPRINTDLGEXA
  Dim DevModeData As DEVMODE
  Dim Fields As CDFields
  Dim hDevMode As Long
  Dim i As Long
  Dim pDevNames As Long
  Dim phDevMode As Long
  Dim Ranges() As PRINTPAGERANGE
  Dim ret As CDPrintDlgExResultActionIDs
  Dim ret2 As Boolean
  Dim tDevNames As DEVNAMES

  ' prepare the API call
  If propInitDeviceData Then
    With DevModeData
      .dmSize = LenB(DevModeData)
      .dmCollate = Abs(propSort)
      .dmColor = IIf(propMonochrome, DMCOLOR_MONOCHROME, DMCOLOR_COLOR)
      .dmCopies = propCopies
      .dmDefaultSource = propPaperSource
      .dmDeviceName = propDeviceName & Chr(0)
      .dmDuplex = propDuplex
      Fields = CDFields.DM_COLLATE Or CDFields.DM_COLOR Or CDFields.DM_COPIES Or CDFields.DM_DEFAULTSOURCE Or CDFields.DM_DUPLEX Or CDFields.DM_ICMINTENT Or CDFields.DM_ICMMETHOD Or CDFields.DM_MEDIATYPE Or CDFields.DM_ORIENTATION Or CDFields.DM_PAPERLENGTH Or CDFields.DM_PAPERSIZE Or CDFields.DM_PAPERWIDTH Or CDFields.DM_PRINTQUALITY Or CDFields.DM_SCALE Or CDFields.DM_TTOPTION Or CDFields.DM_YRESOLUTION
      .dmFields = Fields
      .dmICMIntent = propICMMode
      .dmICMMethod = propICM
      .dmMediaType = propMediaType
      .dmOrientation = propOrientation
      .dmPaperLength = propPaperLength
      .dmPaperSize = propPaperSize
      .dmPaperWidth = propPaperWidth
      .dmPrintQuality = IIf(propxResolution > 0, propxResolution, propPrintQuality)
      .dmScale = propZoomPercent
      .dmTTOption = propTrueTypeMode
      .dmYResolution = propyResolution
    End With

    hDevMode = GlobalAlloc(GMEM_ZEROINIT Or GMEM_FIXED, LenB(DevModeData))
    phDevMode = GlobalLock(hDevMode)
    CopyMemory ByVal phDevMode, DevModeData, LenB(DevModeData)
  End If

  ' ToDo: implement setting hDevNames

  With Data
    .Flags = propPrintDlgFlags
    .ExclusionFlags = propExclusionFlags
    ' ToDo: Why does this cause the API fails?
    '.hInstance = App.hInstance
    .hwndOwner = prophWndParent
    .hDevMode = hDevMode
    .nCopies = propCopies
    .nMaxPage = propMaxPage
    .nMinPage = propMinPage
    .nPageRanges = Me.RangeCount
    .nMaxPageRanges = 100
    ReDim Ranges(1 To .nMaxPageRanges) As PRINTPAGERANGE
    For i = LBound(Ranges) To .nPageRanges
      Ranges(i).nFromPage = Me.RangeFromPage(i)
      Ranges(i).nToPage = Me.RangeToPage(i)
    Next
    .lpPageRanges = VarPtr(Ranges(LBound(Ranges)))
    If isArrayEmpty(arrAdditionalPropertyPages) Then
      .nPropertyPages = 0
    Else
      .nPropertyPages = UBound(arrAdditionalPropertyPages) - LBound(arrAdditionalPropertyPages) + 1
      .lphPropertyPages = VarPtr(arrAdditionalPropertyPages(LBound(arrAdditionalPropertyPages)))
    End If
    .nStartPage = iInitialPropPage
    .lStructSize = Len(Data)
  End With

  ' show up the dialog
  ret2 = (PrintDlgEx(Data) = S_OK)
  ret = Data.dwResultAction

  ' free the memory we used
  If hDevMode Then GlobalFree hDevMode

  If Data.hDevMode Then
    phDevMode = GlobalLock(Data.hDevMode)
    CopyMemory DevModeData, ByVal phDevMode, LenB(DevModeData)
    GlobalUnlock Data.hDevMode
  End If
  If ret2 Then
    ' return the selected printer
    With DevModeData
      propCopies = .dmCopies
      propDuplex = .dmDuplex
      propICM = .dmICMMethod
      propICMMode = .dmICMIntent
      propMediaType = .dmMediaType
      propMonochrome = .dmColor = DMCOLOR_MONOCHROME
      propOrientation = .dmOrientation
      propPaperLength = .dmPaperLength
      propPaperSize = .dmPaperSize
      propPaperSizeName = removeNull(.dmFormName)
      propPaperSource = .dmDefaultSource
      propPaperWidth = .dmPaperWidth
      propPrintQuality = .dmPrintQuality
      propSort = .dmCollate
      propTrueTypeMode = .dmTTOption
      propxResolution = .dmPrintQuality
      propyResolution = .dmYResolution
      propZoomPercent = .dmScale
    End With
    With Data
      If .hDevNames Then
        pDevNames = GlobalLock(.hDevNames)
        CopyMemory tDevNames, ByVal pDevNames, Len(tDevNames)
        propDriverName = getDevNameString(pDevNames, tDevNames.wDriverOffset)
        propDeviceName = getDevNameString(pDevNames, tDevNames.wDeviceOffset)
        propOutputName = getDevNameString(pDevNames, tDevNames.wOutputOffset)
        GlobalUnlock .hDevNames
      End If

      propCopies = .nCopies
      Me.RemoveAllRanges
      For i = LBound(Ranges) To .nPageRanges
        Me.AddRange Ranges(i).nFromPage, Ranges(i).nToPage
      Next
      propPrintDlgFlags = .Flags
      propPrinterhDC = .hDC
      propSort = .Flags And PD_COLLATE
    End With
  End If

  showPrinterEx = ret
End Function
