VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOpenSaveFileDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

  ' public enums

  Public Enum CDOpenFlagsConsts
    OFN_ALLOWMULTISELECT = &H200
    OFN_CREATEPROMPT = &H2000
    OFN_DONTADDTORECENT = &H2000000     ' needs Windows 2000 or higher
    OFN_ENABLEHOOK = &H20
    OFN_ENABLEINCLUDENOTIFY = &H400000
    OFN_ENABLESIZING = &H800000
    OFN_ENABLETEMPLATE = &H40
    OFN_ENABLETEMPLATEHANDLE = &H80
    OFN_EXPLORER = &H80000
    OFN_EXTENSIONDIFFERENT = &H400
    OFN_FILEMUSTEXIST = &H1000
    OFN_FORCESHOWHIDDEN = &H10000000     ' needs Windows 2000 or higher
    OFN_HIDEREADONLY = &H4
    OFN_LONGNAMES = &H200000
    OFN_NOCHANGEDIR = &H8
    OFN_NODEREFERENCELINKS = &H100000
    OFN_NOLONGNAMES = &H40000
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOREADONLYRETURN = &H8000
    OFN_NOTESTFILECREATE = &H10000
    OFN_NOVALIDATE = &H100
    OFN_OVERWRITEPROMPT = &H2
    OFN_PATHMUSTEXIST = &H800
    OFN_READONLY = &H1
    OFN_SHAREAWARE = &H4000
    OFN_SHAREFALLTHROUGH = 2
    OFN_SHARENOWARN = 1
    OFN_SHAREWARN = 0
    OFN_SHOWHELP = &H10
  End Enum

  Public Enum ExCDOpenFlagsConsts
    OFN_EX_NOPLACESBAR = &H1     ' needs Windows 2000 or higher
  End Enum


  ' local constants

  Private Const MAX_PATH = 260
  Private Const Size_OSVERSIONINFO = 148

  ' constants used with GetVersionEx()
  #If Debuging Then
    Private Const VER_PLATFORM_WIN32_WINDOWS = 1
    Private Const VER_PLATFORM_WIN32s = 0
  #End If
  Private Const VER_PLATFORM_WIN32_NT = 2

  ' constants used with SystemParametersInfo()
  #If Debuging Then
    Private Const SPI_GETBEEP = &H1
    Private Const SPI_SETBEEP = &H2
    Private Const SPI_GETMOUSE = &H3
    Private Const SPI_SETMOUSE = &H4
    Private Const SPI_GETBORDER = &H5
    Private Const SPI_SETBORDER = &H6
    Private Const SPI_GETKEYBOARDSPEED = &HA
    Private Const SPI_SETKEYBOARDSPEED = &HB
    Private Const SPI_LANGDRIVER = &HC
    Private Const SPI_ICONHORIZONTALSPACING = &HD
    Private Const SPI_GETSCREENSAVETIMEOUT = &HE
    Private Const SPI_SETSCREENSAVETIMEOUT = &HF
    Private Const SPI_GETSCREENSAVEACTIVE = &H10
    Private Const SPI_SETSCREENSAVEACTIVE = &H11
    Private Const SPI_GETGRIDGRANULARITY = &H12
    Private Const SPI_SETGRIDGRANULARITY = &H13
    Private Const SPI_SETDESKWALLPAPER = &H14
    Private Const SPI_SETDESKPATTERN = &H15
    Private Const SPI_GETKEYBOARDDELAY = &H16
    Private Const SPI_SETKEYBOARDDELAY = &H17
    Private Const SPI_ICONVERTICALSPACING = &H18
    Private Const SPI_GETICONTITLEWRAP = &H19
    Private Const SPI_SETICONTITLEWRAP = &H1A
    Private Const SPI_GETMENUDROPALIGNMENT = &H1B
    Private Const SPI_SETMENUDROPALIGNMENT = &H1C
    Private Const SPI_SETDOUBLECLKWIDTH = &H1D
    Private Const SPI_SETDOUBLECLKHEIGHT = &H1E
    Private Const SPI_GETICONTITLELOGFONT = &H1F
    Private Const SPI_SETDOUBLECLICKTIME = &H20
    Private Const SPI_SETMOUSEBUTTONSWAP = &H21
    Private Const SPI_SETICONTITLELOGFONT = &H22
    Private Const SPI_GETFASTTASKSWITCH = &H23
    Private Const SPI_SETFASTTASKSWITCH = &H24
    Private Const SPI_SETDRAGFULLWINDOWS = &H25
    Private Const SPI_GETDRAGFULLWINDOWS = &H26
    Private Const SPI_GETNONCLIENTMETRICS = &H29
    Private Const SPI_SETNONCLIENTMETRICS = &H2A
    Private Const SPI_GETMINIMIZEDMETRICS = &H2B
    Private Const SPI_SETMINIMIZEDMETRICS = &H2C
    Private Const SPI_GETICONMETRICS = &H2D
    Private Const SPI_SETICONMETRICS = &H2E
    Private Const SPI_SETWORKAREA = &H2F
    Private Const SPI_SETPENWINDOWS = &H31
    Private Const SPI_GETHIGHCONTRAST = &H42
    Private Const SPI_SETHIGHCONTRAST = &H43
    Private Const SPI_GETKEYBOARDPREF = &H44
    Private Const SPI_SETKEYBOARDPREF = &H45
    Private Const SPI_GETSCREENREADER = &H46
    Private Const SPI_SETSCREENREADER = &H47
    Private Const SPI_GETANIMATION = &H48
    Private Const SPI_SETANIMATION = &H49
    Private Const SPI_GETFONTSMOOTHING = &H4A
    Private Const SPI_SETFONTSMOOTHING = &H4B
    Private Const SPI_SETDRAGWIDTH = &H4C
    Private Const SPI_SETDRAGHEIGHT = &H4D
    Private Const SPI_SETHANDHELD = &H4E
    Private Const SPI_GETLOWPOWERTIMEOUT = &H4F
    Private Const SPI_GETPOWEROFFTIMEOUT = &H50
    Private Const SPI_SETLOWPOWERTIMEOUT = &H51
    Private Const SPI_SETPOWEROFFTIMEOUT = &H52
    Private Const SPI_GETLOWPOWERACTIVE = &H53
    Private Const SPI_GETPOWEROFFACTIVE = &H54
    Private Const SPI_SETLOWPOWERACTIVE = &H55
    Private Const SPI_SETPOWEROFFACTIVE = &H56
    Private Const SPI_SETCURSORS = &H57
    Private Const SPI_SETICONS = &H58
    Private Const SPI_GETDEFAULTINPUTLANG = &H59
    Private Const SPI_SETDEFAULTINPUTLANG = &H5A
    Private Const SPI_SETLANGTOGGLE = &H5B
    Private Const SPI_GETWINDOWSEXTENSION = &H5C
    Private Const SPI_SETMOUSETRAILS = &H5D
    Private Const SPI_GETMOUSETRAILS = &H5E
    Private Const SPI_SETSCREENSAVERRUNNING = &H61
    Private Const SPI_SCREENSAVERRUNNING = SPI_SETSCREENSAVERRUNNING
    Private Const SPI_GETFILTERKEYS = &H32
    Private Const SPI_SETFILTERKEYS = &H33
    Private Const SPI_GETTOGGLEKEYS = &H34
    Private Const SPI_SETTOGGLEKEYS = &H35
    Private Const SPI_GETMOUSEKEYS = &H36
    Private Const SPI_SETMOUSEKEYS = &H37
    Private Const SPI_GETSHOWSOUNDS = &H38
    Private Const SPI_SETSHOWSOUNDS = &H39
    Private Const SPI_GETSTICKYKEYS = &H3A
    Private Const SPI_SETSTICKYKEYS = &H3B
    Private Const SPI_GETACCESSTIMEOUT = &H3C
    Private Const SPI_SETACCESSTIMEOUT = &H3D
    Private Const SPI_GETSERIALKEYS = &H3E
    Private Const SPI_SETSERIALKEYS = &H3F
    Private Const SPI_GETSOUNDSENTRY = &H40
    Private Const SPI_SETSOUNDSENTRY = &H41
    Private Const SPI_GETSNAPTODEFBUTTON = &H5F
    Private Const SPI_SETSNAPTODEFBUTTON = &H60
    Private Const SPI_GETMOUSEHOVERWIDTH = &H62
    Private Const SPI_SETMOUSEHOVERWIDTH = &H63
    Private Const SPI_GETMOUSEHOVERHEIGHT = &H64
    Private Const SPI_SETMOUSEHOVERHEIGHT = &H65
    Private Const SPI_GETMOUSEHOVERTIME = &H66
    Private Const SPI_SETMOUSEHOVERTIME = &H67
    Private Const SPI_GETWHEELSCROLLLINES = &H68
    Private Const SPI_SETWHEELSCROLLLINES = &H69
    Private Const SPI_GETMENUSHOWDELAY = &H6A
    Private Const SPI_SETMENUSHOWDELAY = &H6B
    Private Const SPI_GETSHOWIMEUI = &H6E
    Private Const SPI_SETSHOWIMEUI = &H6F
    Private Const SPI_GETMOUSESPEED = &H70
    Private Const SPI_SETMOUSESPEED = &H71
    Private Const SPI_GETSCREENSAVERRUNNING = &H72
    Private Const SPI_GETDESKWALLPAPER = &H73
    Private Const SPI_GETACTIVEWINDOWTRACKING = &H1000
    Private Const SPI_SETACTIVEWINDOWTRACKING = &H1001
    Private Const SPI_GETMENUANIMATION = &H1002
    Private Const SPI_SETMENUANIMATION = &H1003
    Private Const SPI_GETCOMBOBOXANIMATION = &H1004
    Private Const SPI_SETCOMBOBOXANIMATION = &H1005
    Private Const SPI_GETLISTBOXSMOOTHSCROLLING = &H1006
    Private Const SPI_SETLISTBOXSMOOTHSCROLLING = &H1007
    Private Const SPI_GETGRADIENTCAPTIONS = &H1008
    Private Const SPI_SETGRADIENTCAPTIONS = &H1009
    Private Const SPI_GETKEYBOARDCUES = &H100A
    Private Const SPI_SETKEYBOARDCUES = &H100B
    Private Const SPI_GETMENUUNDERLINES = SPI_GETKEYBOARDCUES
    Private Const SPI_SETMENUUNDERLINES = SPI_SETKEYBOARDCUES
    Private Const SPI_GETACTIVEWNDTRKZORDER = &H100C
    Private Const SPI_SETACTIVEWNDTRKZORDER = &H100D
    Private Const SPI_GETHOTTRACKING = &H100E
    Private Const SPI_SETHOTTRACKING = &H100F
    Private Const SPI_GETMENUFADE = &H1012
    Private Const SPI_SETMENUFADE = &H1013
    Private Const SPI_GETSELECTIONFADE = &H1014
    Private Const SPI_SETSELECTIONFADE = &H1015
    Private Const SPI_GETTOOLTIPANIMATION = &H1016
    Private Const SPI_SETTOOLTIPANIMATION = &H1017
    Private Const SPI_GETTOOLTIPFADE = &H1018
    Private Const SPI_SETTOOLTIPFADE = &H1019
    Private Const SPI_GETCURSORSHADOW = &H101A
    Private Const SPI_SETCURSORSHADOW = &H101B
    Private Const SPI_GETMOUSESONAR = &H101C
    Private Const SPI_SETMOUSESONAR = &H101D
    Private Const SPI_GETMOUSECLICKLOCK = &H101E
    Private Const SPI_SETMOUSECLICKLOCK = &H101F
    Private Const SPI_GETMOUSEVANISH = &H1020
    Private Const SPI_SETMOUSEVANISH = &H1021
    Private Const SPI_GETFLATMENU = &H1022
    Private Const SPI_SETFLATMENU = &H1023
    Private Const SPI_GETDROPSHADOW = &H1024
    Private Const SPI_SETDROPSHADOW = &H1025
    Private Const SPI_GETBLOCKSENDINPUTRESETS = &H1026
    Private Const SPI_SETBLOCKSENDINPUTRESETS = &H1027
    Private Const SPI_GETUIEFFECTS = &H103E
    Private Const SPI_SETUIEFFECTS = &H103F
    Private Const SPI_GETFOREGROUNDLOCKTIMEOUT = &H2000
    Private Const SPI_SETFOREGROUNDLOCKTIMEOUT = &H2001
    Private Const SPI_GETACTIVEWNDTRKTIMEOUT = &H2002
    Private Const SPI_SETACTIVEWNDTRKTIMEOUT = &H2003
    Private Const SPI_GETFOREGROUNDFLASHCOUNT = &H2004
    Private Const SPI_SETFOREGROUNDFLASHCOUNT = &H2005
    Private Const SPI_GETCARETWIDTH = &H2006
    Private Const SPI_SETCARETWIDTH = &H2007
    Private Const SPI_GETMOUSECLICKLOCKTIME = &H2008
    Private Const SPI_SETMOUSECLICKLOCKTIME = &H2009
    Private Const SPI_GETFONTSMOOTHINGTYPE = &H200A
    Private Const SPI_SETFONTSMOOTHINGTYPE = &H200B
    Private Const SPI_GETFONTSMOOTHINGCONTRAST = &H200C
    Private Const SPI_SETFONTSMOOTHINGCONTRAST = &H200D
    Private Const SPI_GETFOCUSBORDERWIDTH = &H200E
    Private Const SPI_SETFOCUSBORDERWIDTH = &H200F
    Private Const SPI_GETFOCUSBORDERHEIGHT = &H2010
    Private Const SPI_SETFOCUSBORDERHEIGHT = &H2011
    Private Const SPI_GETFONTSMOOTHINGORIENTATION = &H2012
    Private Const SPI_SETFONTSMOOTHINGORIENTATION = &H2013
    Private Const SPIF_UPDATEINIFILE = &H1
    Private Const SPIF_SENDWININICHANGE = &H2
    Private Const SPIF_SENDCHANGE = SPIF_SENDWININICHANGE
  #End If
  Private Const SPI_GETWORKAREA = &H30


  ' local UDTs

  Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    ' needs Windows 2000 or higher
    pvReserved As Long
    dwReserved As Long
    FlagsEx As Long
  End Type

  Private Type OSVERSIONINFOEX
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
    ' needs Windows NT4 SP6 or higher
    wServicePackMajor As Integer
    wServicePackMinor As Integer
    wSuiteMask As Integer
    wProductType As Byte
    wReserved As Byte
  End Type

  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type


  ' local vars

  Private colFilters As Collection
  Private mASM() As Byte


  ' vars used to store the values of public properties

  Private propActiveFilter As Integer
  Private propCaption As String
  Private propDefaultExtension As String
  Private propDefaultFile As String
  Private propExOpenFlags As ExCDOpenFlagsConsts
  Private prophWndParent As Long
  Private propOpenFlags As CDOpenFlagsConsts
  Private propStartDirection As String


  ' local API-declarations

  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Ziel As Any, Quelle As Any, ByVal Size As Long)
  Private Declare Function GetOpenFileName Lib "comdlg32" Alias "GetOpenFileNameA" (Data As OPENFILENAME) As Long
  Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
  Private Declare Function GetSaveFileName Lib "comdlg32" Alias "GetSaveFileNameA" (Data As OPENFILENAME) As Long
  Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (Data As Any) As Long
  Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, rc As RECT) As Long
  Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal Repaint As Long) As Long
  Private Declare Function PathAddBackslash Lib "shlwapi" Alias "PathAddBackslashA" (ByVal Path As String) As Long
  Private Declare Function PathIsDirectory Lib "shlwapi" Alias "PathIsDirectoryA" (ByVal Path As String) As Long
  Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal ParamInfo As Long, ByVal ParamData1 As Long, ParamData2 As Any, ByVal Flags As Long) As Long


' events

Private Sub Class_Initialize()
  Dim ptr As Long

  ' get the VTable-Ptr
  CopyMemory ptr, ByVal ObjPtr(Me), LenB(ptr)
  ' get the pointer to the first public procedure (must be our WinMain)
  CopyMemory ptr, ByVal ptr + &H1C, LenB(ptr)
  ReDim mASM(0 To 42) As Byte     ' bytes 38 to 42 will receive the return value of our WinMain
  ' lay the frame pointer onto the stack (what for?)
  mASM(0) = &H55     ' PUSH EBP
  ' get the stack pointer into EBP
  CopyMemory mASM(1), &H68EC8B, 3     ' MOV EBP, ESP
  ' lay the offset of the return value's address onto the stack
  CopyMemory mASM(4), VarPtr(mASM(39)), 4   ' PUSH dword ptr [offset of return address]

  ' lay the addresses of the WinMain's arguments onto the stack
  ' 4th argument
  CopyMemory mASM(8), &H1475FF, 3     ' PUSH dword ptr [EBP+14h]
  ' 3rd argument
  CopyMemory mASM(11), &H1075FF, 3     ' PUSH dword ptr [EBP+10h]
  ' 2nd argument
  CopyMemory mASM(14), &HC75FF, 3     ' PUSH dword ptr [EBP+0Ch]
  ' 1st argument
  CopyMemory mASM(17), &H875FF, 3     ' PUSH dword ptr [EBP+08h]

  ' lay the current object's pointer onto the stack
  mASM(20) = &H68     ' PUSH 32-bit-immediate
  CopyMemory mASM(21), ObjPtr(Me), 4     ' the immediate
  ' call our WinMain
  mASM(25) = &HE8     ' CALL 32-bit relative code address
  CopyMemory mASM(26), ptr - VarPtr(mASM(30)), 4    ' the relative address
  ' move the WinMain's return value into EAX
  mASM(30) = &HA1     ' MOV EAX, dword ptr [offset of return address]
  CopyMemory mASM(31), VarPtr(mASM(39)), 4     ' the offset
  ' leave our WinMain
  mASM(35) = &HC9     ' LEAVE
  ' return from our WinMain
  mASM(36) = &HC2     ' RET 10h     (seems to be some offset - it's the size of all arguments together)
  CopyMemory mASM(37), &H10, 2    ' can't do the "RET 10h" in 1 line - probably alignment problems

  Set colFilters = New Collection
End Sub

Private Sub Class_Terminate()
  Set colFilters = Nothing
End Sub


' This must be the first public method!!
' disadvantage of the Assembler trick: we now have 1 method for all dialogs
Public Function GenericHookProc(ByVal hDlg As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Const WM_INITDIALOG = &H110
  Dim hWnd As Long
  Dim rc As RECT
  Dim rc2 As RECT
  Dim X As Long
  Dim Y As Long

  Select Case msg
    Case WM_INITDIALOG
      hWnd = GetParent(hDlg)
      GetWindowRect hWnd, rc
      If SystemParametersInfo(SPI_GETWORKAREA, 0, rc2, 0) = 0 Then
        ' call failed - just use standard screen:
        rc2.Left = 0
        rc2.Top = 0
        rc2.Right = Screen.Width \ Screen.TwipsPerPixelX
        rc2.Bottom = Screen.Height \ Screen.TwipsPerPixelY
      End If
      If (rc.Right > 0) And (rc.Bottom > 0) Then
        X = rc2.Left + (((rc2.Right - rc2.Left) - (rc.Right - rc.Left)) \ 2)
        Y = rc2.Top + (((rc2.Bottom - rc2.Top) - (rc.Bottom - rc.Top)) \ 2)
        MoveWindow hWnd, X, Y, rc.Right - rc.Left, rc.Bottom - rc.Top, 1
      End If
  End Select
End Function


' public properties

Public Property Get ActiveFilter() As Integer
  ActiveFilter = propActiveFilter
End Property

Public Property Let ActiveFilter(ByVal New_ActiveFilter As Integer)
  propActiveFilter = New_ActiveFilter
End Property

Public Property Get Caption() As String
  Caption = propCaption
End Property

Public Property Let Caption(ByVal New_Caption As String)
  propCaption = New_Caption
End Property

Public Property Get DefaultExtension() As String
  DefaultExtension = propDefaultExtension
End Property

Public Property Let DefaultExtension(ByVal New_DefaultExtension As String)
  propDefaultExtension = New_DefaultExtension
End Property

Public Property Get DefaultFile() As String
  DefaultFile = propDefaultFile
End Property

Public Property Let DefaultFile(ByVal New_DefaultFile As String)
  propDefaultFile = New_DefaultFile
End Property

Public Property Get ExOpenFlags() As ExCDOpenFlagsConsts
  ExOpenFlags = propExOpenFlags
End Property

Public Property Let ExOpenFlags(ByVal New_ExOpenFlags As ExCDOpenFlagsConsts)
  propExOpenFlags = New_ExOpenFlags
End Property

Public Property Get FilterCount() As Integer
  FilterCount = colFilters.Count / 2
End Property

Public Property Get FilterDescription(ByVal iFilter As Integer) As String
  If Not isValidNumber(iFilter, 1, Me.FilterCount) Then
    Err.Raise 9
    Exit Property
  End If

  FilterDescription = colFilters(iFilter * 2 - 1)
End Property

Public Property Get FilterMask(ByVal iFilter As Integer) As String
  If Not isValidNumber(iFilter, 1, Me.FilterCount) Then
    Err.Raise 9
    Exit Property
  End If

  FilterMask = colFilters(iFilter * 2)
End Property

Public Property Get hWndParent() As Long
  hWndParent = prophWndParent
End Property

Public Property Let hWndParent(ByVal New_hWndParent As Long)
  prophWndParent = New_hWndParent
End Property

Public Property Get OpenFlags() As CDOpenFlagsConsts
  OpenFlags = propOpenFlags
End Property

Public Property Let OpenFlags(ByVal New_OpenFlags As CDOpenFlagsConsts)
  propOpenFlags = New_OpenFlags
End Property

Public Property Get startDirection() As String
  startDirection = propStartDirection
End Property

Public Property Let startDirection(ByVal New_startDirection As String)
  propStartDirection = New_startDirection
End Property


' local methods

' adds a backslash to <txt> (if there isn't already one)
Private Function addBackslash(ByVal txt As String, Optional ByVal OnlyIfDirectory As Boolean = True) As String
  If OnlyIfDirectory Then
    If Not isDirectory(txt) Then
      addBackslash = Trim(removeNull(txt))
      Exit Function
    End If
  End If
  txt = txt & String(2, Chr(0))
  PathAddBackslash txt
  txt = Trim(removeNull(txt))

  addBackslash = txt
End Function

' returns a string containing all filters
' format: <description> & Chr(0) & <mask> & Chr(0)...
' the string ends with two Chr(0)s
Private Function getFilters() As String
  Dim Description As String
  Dim i As Integer
  Dim Mask As String
  Dim ret As String

  For i = 1 To colFilters.Count Step 2
    Description = colFilters(i)
    Mask = colFilters(i + 1)

    ret = ret & Description & Chr(0) & Mask & Chr(0)
  Next
  If ret <> "" Then ret = ret & Chr(0)

  getFilters = ret
End Function

' checks whether <txt> is a directory
Private Function isDirectory(ByVal txt As String) As Boolean
  If txt = "" Then Exit Function

  isDirectory = PathIsDirectory(txt)
End Function

' checks whether <txt> is a valid number between <LoBound> and <HiBound>
Private Function isValidNumber(ByVal txt As String, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  Dim i As Integer
  Dim ret As Boolean
  Dim tmp As String

  If txt = "" Then Exit Function

  ret = True

  tmp = txt
  If Left(tmp, 1) = "-" Then tmp = Mid(tmp, 2)

  ' we need to check every single char
  For i = 1 To Len(tmp)
    If InStr("0123456789", Mid(tmp, i, 1)) = 0 Then ret = False
  Next
  If ret Then
    ' check the bounds
    ret = isWithinRange(CLng(txt), LoBound, HiBound)
  End If

  isValidNumber = ret
End Function

' checks whether the OS is Windows 2000 or higher
Private Function isWin2kOrHigher() As Boolean
  Dim OSVerData As OSVERSIONINFOEX

  With OSVerData
    .dwOSVersionInfoSize = Size_OSVERSIONINFO
    GetVersionEx OSVerData

    Select Case .dwPlatformId
      Case VER_PLATFORM_WIN32_NT
        isWin2kOrHigher = (.dwMajorVersion >= 5)
    End Select
  End With
End Function

' checks whether <Num> is placed between <LoBound> and <HiBound>
Private Function isWithinRange(ByVal Num As Long, ByVal LoBound As Long, ByVal HiBound As Long) As Boolean
  isWithinRange = ((Num >= LoBound) And (Num <= HiBound))
End Function

' cuts <txt> at the first occurance of two Chr(0)s
Private Function removeDoubleNull(ByVal txt As String) As String
  Dim pos As Integer

  pos = InStr(txt, String(2, Chr(0)))
  If pos Then txt = Left(txt, pos - 1)
  removeDoubleNull = txt
End Function

' cuts <txt> at the first occurance of Chr(0)
Private Function removeNull(ByVal txt As String) As String
  Dim pos As Integer

  pos = InStr(txt, Chr(0))
  If pos Then txt = Left(txt, pos - 1)
  removeNull = txt
End Function


' public methods

' adds a filter
Public Sub AddFilter(ByVal Description As String, ByVal Mask As String, Optional ByVal After As Integer = -1)
  If After > 0 Then
    colFilters.Add Description, , , After * 2
    colFilters.Add Mask, , , After * 2 + 1
  Else
    colFilters.Add Description
    colFilters.Add Mask
  End If
End Sub

' removes all filters
Public Sub RemoveAllFilters()
  Set colFilters = New Collection
End Sub

' removes the filter <iFilter>
Public Sub RemoveFilter(ByVal iFilter As Integer)
  ' remove mask
  colFilters.Remove iFilter * 2
  ' remove description
  colFilters.Remove iFilter * 2 - 1
End Sub

' pops up an "Open file..."-dialog and returns the selected file
Public Function showOpen(File As String) As Boolean
  Dim arrFiles() As String
  Dim Data As OPENFILENAME
  Dim Folder As String
  Dim i As Long
  Dim pos As Long
  Dim ret As Boolean

  ' prepare the API call
  With Data
    .Flags = propOpenFlags
    .FlagsEx = propExOpenFlags
    .hInstance = App.hInstance
    .hwndOwner = prophWndParent
    .lpstrDefExt = propDefaultExtension
    .lpstrFile = propDefaultFile & String(MAX_PATH - Len(propDefaultFile), Chr(0))
    .lpstrFileTitle = Space(MAX_PATH)
    .lpstrFilter = getFilters
    .lpstrInitialDir = propStartDirection
    .lpstrTitle = propCaption
    .nFilterIndex = propActiveFilter
    .nMaxFile = MAX_PATH
    .nMaxFileTitle = MAX_PATH
    #If UseHooking Then
      .Flags = .Flags Or CDOpenFlagsConsts.OFN_ENABLEHOOK
      .lpfnHook = VarPtr(mASM(0))
    #End If
    .lStructSize = LenB(Data) - IIf(isWin2kOrHigher, 0, 12)

    ' show up the dialog
    ret = GetOpenFileName(Data)

    If ret Then
      ' return the selected file
      File = removeDoubleNull(.lpstrFile)
      If propOpenFlags And CDOpenFlagsConsts.OFN_ALLOWMULTISELECT Then
        arrFiles = Split(File, Chr(0))
        Folder = addBackslash(arrFiles(0))
        For i = LBound(arrFiles) + 1 To UBound(arrFiles)
          arrFiles(i) = Folder & arrFiles(i)
        Next
        File = Join(arrFiles, "|")
        pos = InStr(File, "|")
        File = Mid(File, pos + 1)
      End If
    End If
  End With

  showOpen = ret
End Function

' pops up an "Save file..."-dialog and returns the selected file
Public Function showSave(File As String) As Boolean
  Dim Data As OPENFILENAME
  Dim ret As Boolean

  ' prepare the API call
  With Data
    .Flags = propOpenFlags
    .FlagsEx = propExOpenFlags
    .hInstance = App.hInstance
    .hwndOwner = prophWndParent
    .lpstrDefExt = propDefaultExtension
    .lpstrFile = propDefaultFile & String(MAX_PATH - Len(propDefaultFile), Chr(0))
    .lpstrFileTitle = Space(MAX_PATH)
    .lpstrFilter = getFilters
    .lpstrInitialDir = propStartDirection
    .lpstrTitle = propCaption
    .nFilterIndex = propActiveFilter
    .nMaxFile = MAX_PATH
    .nMaxFileTitle = MAX_PATH
    #If UseHooking Then
      .Flags = .Flags Or CDOpenFlagsConsts.OFN_ENABLEHOOK
      .lpfnHook = VarPtr(mASM(0))
    #End If
    .lStructSize = LenB(Data) - IIf(isWin2kOrHigher, 0, 12)

    ' show up the dialog
    ret = GetSaveFileName(Data)

    If ret Then
      ' return the selected file
      File = removeDoubleNull(.lpstrFile)
    End If
  End With

  showSave = ret
End Function
